.include "m16Adef.inc"
.def RL = r0
.def RH = r1
.def OCAH = r2
.def OCAL = r3
.def OCNH = r4
.def OCNL = r5
.def PAR0 = r6
.def TMPL1 = r10
.def TMPL2 = r11
.def TMPL3 = r12
.def TMPL4 = r13
.def TMPL5 = r14
.def TMPL6 = r15
.def TMP1 = r16
.def TMP2 = r17
.def TMP3 = r18
.def TMP4 = r19
.def LICZA = r20
.def LICZB = r21
.def DATA = r22
.def D1 = r23
.def D2 = r24
.def D3 = r25
; Opis wyprowadze Portw
; PA0 - pomiar napicia wyjciowego TX
; PA1 - S-metr
; PA2 - NC
; PA3 - VCC-suma czstotliwoci VFO i BFO, GND-|rnica czstotliwoci VFO i BFO|
; PA4 - dana LSB INPUT B
; PA5 - dana MSB INPUT B
; PA6 - dana MSB INPUT A
; PA7 - dana LSB INPUT A
; PB0 - przeczanie TX(VCC) lub RX(GND)
; PB1 - R/W LCD
; PB2 - E LCD
; PB3 - RS LCD
; PB4 - bit danej LCD(LSB)
; PB5 - bit danej LCD		MOSI
; PB6 - bit danej LCD		MISO
; PB7 - bit danej LCD(MSB)	SCK
; PC0-7 - szyna danych z licznikw zewntrznych
; PD0 - NC (RX RS232)
; PD1 - NC (TX RS232)
; PD2 - INPUT A (INT0)
; PD3 - INPUT B (INT1)
; PD4 - FM(0), CW(1)
; PD5 - wczanie licznika, zliczanie(0), przestj(1)
; PD6 - zerowanie licznikw, RESET(1), liczenie (0)
; PD7 - modulacja, SSB(1), AM/FM(0)
; Mapa alokacji pamici SRAM
	.cseg
	.org 0x0000
	jmp START			; adres przerwania RESET
	rcall COUNTER_A		; adres przerwania INT0
	reti				; pusta instrukcja
	rcall COUNTER_B		; adres przerwania INT1
	reti				; pusta instrukcja
	reti				; adres przerwania TIMER2 COMP
	nop					; pusta instrukcja
	reti				; adres przerwania TIMER2 OVF
	nop					; pusta instrukcja
	reti				; adres przerwania TIMER1 CAPT
	nop					; pusta instrukcja
	rcall INT_HANDLER	; adres przerwania TIMER1 COMP A
	reti				; zakoczenie przerwania TIMER1 COMP A
	reti				; adres przerwania TIMER1 COMP B
	nop					; pusta instrukcja
	reti				; adres przerwania TIMER1 OVF
	nop					; pusta instrukcja
	reti				; adres przerwania TIMER0 OVF
	nop					; pusta instrukcja
	reti				; adres przerwania SPI, STC
	nop					; pusta instrukcja
	reti				; adres przerwania USART, RXC
	reti				; pusta instrukcja
	reti				; adres przerwania USART, UDRE
	nop					; pusta instrukcja
	reti				; adres przerwania USART, TXC
	nop					; pusta instrukcja
	reti				; adres przerwania ADC
	nop					; pusta instrukcja
	reti				; adres przerwania EE_RDY
	nop					; pusta instrukcja
	reti				; adres przerwania ANA_COMP
	nop					; pusta instrukcja
	reti				; adres przerwania TWI
	nop					; pusta instrukcja
	reti				; adres przerwania INT2
	nop					; pusta instrukcja
	reti				; adres przerwania TIMER0 COMP
	nop					; pusta instrukcja
	reti				; adres przerwania SPM_RDY
	nop						; pusta instrukcja
;
COUNTER_A:
	inc LICZA				; zwikszenie LICZA o 1
	nop
	nop
	nop
	nop
	ret

COUNTER_B:
	inc LICZB				; zwikszenie LICZB o 1
	nop
	nop
	nop
	nop
	ret
;
INT_HANDLER:
	sbis PIND,PIND5				; gdy PIND5=1 to skok do sbi PD5
	rjmp I_H_1				; skok do I_H_1
	nop
	sbi PORTD,PD5				; ustawienie 5-tego bitu w PORT D
	ldi TMP1,0x80			; rejestr TCCR1A = 1000 0000
	out TCCR1A,TMP1			; tj. COM1A1:0=2, COM1B1:0=0, FOC1A = 0
	set						; ustawienie flagi T
	rjmp I_H_2				; skok do I_H_2
I_H_1:
	cbi PORTD,PD5				; wyzerowanie 5-tego bitu w PORT D
	ldi TMP1,0xC0			; rejestr TCCR1A = 1100 0000
	out TCCR1A,TMP1			; tj. COM1A1:0=3, COM1B1:0=0, FOC1A = 0
	clt						; wyzerowanie flagi T
	nop
	nop
I_H_2:
	mov TMP1,OCAH			; wpisanie OCAH do TMP1
	mov TMP2,OCNH			; wpisanie OCNH do TMP2
	mov OCAH,TMP2			; wpisanie TMP2 do OCAH
	mov OCNH,TMP1			; wpisanie TMP1 do OCNH
	mov TMP1,OCAL			; wpisanie OCAL do TMP1
	mov TMP2,OCNL			; wpisanie OCNL do TMP2
	mov OCAL,TMP2			; wpisanie TMP2 do OCAL
	mov OCNL,TMP1			; wpisanie TMP1 do OCNL
	ldi TMP1,0x00			; zerowanie TMP1
	out TCNT1H,TMP1			; zerowanie licznika
	out TCNT1L,TMP1			;	Timer/Counter 1
	out OCR1AH,OCAH			; wpisz t
	out OCR1AL,OCAL			;	dan do rejestru OCR1A
	ldi TMP1,0x0C			; rejestr TCCR1B = 0000 1100
	out TCCR1B,TMP1			; tj.  WGM13:0=4, CS12:0=5
	ldi TMP1,0x10			; uaktywnij przerwanie
	out TIMSK,TMP1			;			OCIE1A
	nop
	nop
	nop
	ret
;
START:
; inicjalizacja procesora
;	cli
	ldi TMP1,0x04			; zaaduj starszy
	out SPH,TMP1			;		bajt stosu
	ldi TMP1,0x5F			; zaaduj modszy
	out SPL,TMP1			;		bajt stosu
	ldi TMP1,0x0A			; wpisanie 0x0A do TMP1
	out MCUCR,TMP1			; ustawienie wyzwalania opadajcym zboczem INT0 i INT1
	ldi TMP1,0xC0			; wpisanie 0xC0 do TMP1
	out GICR,TMP1			; wczenie przerwa INT0 i INT1
; inicjalizacja portw
	ldi TMP1,0xF8			; wpisanie 0xF8 do TMP1
	out DDRA,TMP1			; wysanie TMP1 do DDRA
	out PORTA,TMP1			; wysanie TMP1 do Portu A
	clr TMP1				; wyzerowanie TMP1
	out DDRC,TMP1			; wysanie TMP1 do DDRC
	ldi TMP1,0xF0			; wpisanie 0xF0 do TMP1
	out DDRD,TMP1			; wysanie TMP1 do DDRD
	ldi TMP1,0xF0			; wpisanie 0xF0 do TMP1
	out PORTD,TMP1			; wysanie TMP1 do PORTD (PD6=1 - zerowanie licznikw, PD5=1 - zatrzymanie zliczania)
	ldi TMP1,0xFF			; wpisanie 0xFF do TMP1
	out DDRB,TMP1			; wysanie TMP1 do DDRB
	clr TMP1				; wyzerowanie TMP1
	out PORTB,TMP1			; wysanie TMP1 do PORTB
; inicjalizacja czasw: zliczania i wywietlania
	call LCD_INIT			; inicjalizacja wywietlacza LCD
	call INIT_ADC			; inicjalizacja woltomierza
	ldi TMP1,0x18			; wpisanie 0x15 do TMP1
	mov OCAH,TMP1			; przepisanie TMP1 do OCAH
	ldi TMP1,0x69			; wpisanie 0xF8 do TMP1 (przerwa dla 16000.0 kHz)
	mov OCAL,TMP1			; przepisanie TMP1 do OCAL
	ldi TMP1,0x18			; wpisanie 0x02 do TMP1 (zliczanie dla 16000.0 kHz)
	mov OCNH,TMP1			; przepisanie TMP1 do OCNH
	ldi TMP1,0x69			; wpisanie 0x70 do TMP1 (zliczanie dla 16000.0 Hz)
	mov OCNL,TMP1			; przepisanie TMP1 do OCNL
	cbi PORTD,PD6			; wyzerowanie PD6 (wyczenie zerowania)
	call COEF
	call TIMER1_INIT		; inicjalizacja Timer/Counter 1
	ldi TMP1,0xC0			; wpisanie 0xC0 do TMP1
	mov PAR0,TMP1			; przepisanie TMP1 do PAR0
	sbi PORTD,PD5			; wstrzymanie zliczania
	set						; T=0 gdy zlicznie impulsw, T=1 w przerwie
	clr LICZA				; wyzerowanie rejestru LICZA
	clr LICZB				; wyzerowanie rejestru LICZB
	sei						; wczenie przerwa
	nop
	nop
	nop
	nop
	nop
LOOP:
	nop
	nop
	nop
	nop
	nop
	brts SHOW				; gdy T=1 to skocz do SHOW
CONTINUE:
	rjmp LOOP				; skocz do LOOP
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;
SHOW:
	clt						; wyzerowanie flagi T
	mov TMP1,PAR0			; przepisanie PAR0 do TMP1
	nop
	andi TMP1,0x80			; wyodrbnienie najstarszego bitu TMP1
	brne SHOW_PAR0			; gdy rny od zera to skok do SHOW_PAR0
	rcall READ_DATA			; wywoanie procedury czytania danych
	ldi YL,0x60				; wpisanie 0x60 do YL
	call MOVE_UP		
	call CORR
	ldi YL,0x60				; wpisanie 0x60 do YL
	call MOVE_DOWN		
	ldi YL,0x63				; wpisanie 0x63 do YL
	call MOVE_UP		
	call CORR
	ldi YL,0x63				; wpisanie 0x63 do YL
	call MOVE_DOWN		
	call MODE				; wywoanie procedury MODE
	sbis PINA,PINA3			; pominicie nastpnej instrukcji gdy PINA3=1
	rcall ODJ				; wywoanie procedury odejmowania czstotliwoci
	nop
	sbic PINA,PINA3			; pominicie nastpnej instrukcji gdy PINA3=0
	rcall SUM				; wywoanie procedury sumowania czstotliwoci
	nop
	ldi ZL,0x66				; wpisanie 0x66 do ZL
	ldi ZH,0x00				; wpisanie 0x00 do ZH
	rcall BIT2DEC			; konwersja z binarnego na dziesitne
	ldi DATA,0x80			; wpisanie 0x80 do DATA (adres pierwszej cyfry na LCD)
	ldi TMP4,0x08			; wpisanie 0x08 do TMP4 (liczba cyfr do wypisania)
	rcall DATA2LCD			; wypisanie DATA na LCD
	sbis PINB,PINB0			; pominicie nastpnej instrukcji gdy PINB0=1
	rcall RX_ON				; wywoanie procedury pokazujcej na LCD parametry RXa
	nop
	sbic PINB,PINB0			; pominicie nastpnej instrukcji gdy PINB0=0
	rcall TX_ON				; wywoanie procedury pokazujcej na LCD parametry TXa
	nop
	nop
	nop
SHOW_PAR0:
	mov TMP1,PAR0			; wpisanie PAR0 do TMP1
	clc						; zerowanie flagi C
	rol TMP1				; rotowanie TMP1 w lewo przez Carry
	mov PAR0,TMP1			; wpisanie TMP1 do PAR0
	clc						; zerowanie flagi C
	sbi PORTD,PD6			; ustawienie bitu 6 w PORTD
	nop
	nop
;*************************************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	cbi PORTD,PD6			; wyzerowanie bitu 6 w PORTD
	nop
	nop
;*************************************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	clr LICZA				; wyzerowanie LICZA
	clr LICZB				; wyzerowanie LICZB
	rjmp CONTINUE
;
RX_ON:
; wypisywanie i obliczanie danych dla odbiornika (RX, S)
; 3FF (1023) 9+60 ^ 2.5575 V
;     (1022)      -
; 3A5 ( 933) 9+50 ^ 2.3325 V
;     ( 932)      -
; 34B ( 843) 9+40 ^ 2.1075 V
;     ( 842)      -
; 2F1 ( 753) 9+30 ^ 1.8825 V
;     ( 752)      -
; 297 ( 663) 9+20 ^ 1.6575 V
;     ( 662)      -
; 23D ( 573) 9+10 ^ 1.4325 V
;     ( 572)      -
; 1E3 ( 483) 9    ^ 1.2075 V
;     ( 482)      -
; 1AD ( 429) 8    ^ 1.0725 V
;     ( 428)      -
; 177 ( 375) 7    ^ 0.9375 V
;     ( 374)      -
; 141 ( 321) 6    ^ 0.8025 V
;     ( 320)      -
; 10B ( 267) 5    ^ 0.6675 V
;     ( 266)      -
;  D5 ( 213) 4    ^ 0.5325 V
;     ( 212)      -
;  9F ( 159) 3    ^ 0.3975 V
;     ( 158)      -
;  69 ( 105) 2    ^ 0.2625 V
;     ( 104)      -
;  33 (  51) 1    ^ 0.1275 V
;     (  50)      -
;   0 (   0) 0    ^ 0.     V
	ldi DATA,0x8E			; wpisanie 0x8E do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x3C			; odejmowanie 0x3C od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x6E			; wpisanie 0x6E do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x6D			; odejmowanie 0x6D od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x33			; odejmowanie 0x33 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	sbi ADMUX,0				; ustawianie bitu 0 rejestru ADMUX - ustawianie ADC1
	cbi ADMUX,1				; zerowanie bitu 1 rejestru ADMUX
	call READ_ADC			; odczyt woltomierza
;************************************************
	nop
	ldi YL,0x6A				; wpisanie 0x6A do YL - adres SRAM ADCL
	ldi YH,0x00				; wpisanie 0x00 do YH
	ld TMP1,Y+				; wpisanie danej SRAM spod adresu Y do TMP1 i zwikszenie Y o 1 (czytanie ADCL)
	ld TMP2,Y				; wpisanie danej SRAM spod adresu Y do TMP2                     (czytanie ADCH)
	cpi TMP2,0x03			; porwnanie TMP2 z 0x03
	breq ADCH03I			; gdy rwne to skok do ADCH03I
	cpi TMP2,0x02			; porwnanie TMP2 z 0x02
	breq ADCH02I			; gdy rwne to skok do ADCH02I
	cpi TMP2,0x01			; porwnanie TMP2 z 0x01
	breq ADCH01I			; gdy rwne to skok do ADCH01I
	cpi TMP2,0x00			; porwnanie TMP2 z 0x00
	brne ADCHUN				; gdy rne to skok do ADCHUN
	jmp ADCH00				; skok do ADCH00
ADCH01I:
	jmp ADCH01				; skok do ADCH01
ADCH02I:
	jmp ADCH02				; skok do ADCH02
ADCH03I:
	jmp ADCH03				; skok do ADCH03
;************************************************
ADCHUN:
	nop
	nop
	nop
	nop
	nop
	ret
ADC0051I:
	jmp ADC0051				; skok do ADC0051
ADC0069I:
	jmp ADC0069				; skok do ADC0069
ADCH00:
	cpi TMP1,0x33			; porwnanie TMP1 z 0x33
	brlo ADC0051I			; gdy mniejsze to skok do ADC0051I
	cpi TMP1,0x69			; porwnanie TMP1 z 0x69
	brlo ADC0069I			; gdy mniejsze to skok do ADC0069I
	cpi TMP1,0x9F			; porwnanie TMP1 z 0x9F
	brlo ADC009F			; gdy mniejsze to skok do ADC009F
	cpi TMP1,0xD5			; porwnanie TMP1 z 0xD5
	brlo ADC00D5			; gdy mniejsze to skok do ADC00D5
ADC010B:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x8E			; odjcie 0x8E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x14			; odjcie 0x14 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC00D5:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x8F			; odjcie 0x8F od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x13			; odjcie 0x13 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	jmp ADCHUN				; skok do ADCHUN
ADC009F:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x90			; odjcie 0x90 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x12			; odjcie 0x12 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC0069:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x91			; odjcie 0x91 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x11			; odjcie 0x11 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC0051:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x92			; odjcie 0x92 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x10			; odjcie 0x10 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC010BI:
	nop
	nop
	nop
	jmp ADC010B				; skok do ADC010B
ADC0141I:
	jmp ADC0141				; skok do ADC0141
ADC0177I:
	jmp ADC0177				; skok do ADC0177
ADCH01:
	cpi TMP1,0x0B			; porwnanie TMP1 z 0x0B
	brlo ADC010BI			; gdy mniejsze to skok do ADC010BI
	cpi TMP1,0x41			; porwnanie TMP1 z 0x41
	brlo ADC0141I			; gdy mniejsze to skok do ADC0141I
	cpi TMP1,0x77			; porwnanie TMP1 z 0x77
	brlo ADC0177I			; gdy mniejsze to skok do ADC0177I
	cpi TMP1,0xAD			; porwnanie TMP1 z 0xAD
	brlo ADC01AD			; gdy mniejsze to skok do ADC01AD
	cpi TMP1,0xE3			; porwnanie TMP1 z 0xE3
	brlo ADC01E3			; gdy mniejsze to skok do ADC01E3
ADC023D:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x19			; odjcie 0x19 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	jmp ADCHUN				; skok do ADCHUN
ADC01E3:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x8A			; odjcie 0x8A od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x18			; odjcie 0x18 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC01AD:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x8B			; odjcie 0x8B od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x17			; odjcie 0x17 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC0177:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x8C			; odjcie 0x8C od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x16			; odjcie 0x16 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	jmp ADCHUN				; skok do ADCHUN
ADC0141:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x8D			; odjcie 0x8D od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x15			; odjcie 0x15 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC023DI:
	nop
	nop
	nop
	nop
	nop
	nop
	jmp ADC023D				; skok do ADC023D
ADCH02:
	cpi TMP1,0x3D			; porwnanie TMP1 z 0x3D
	brlo ADC023DI			; gdy mniejsze to skok do ADC023DI
	cpi TMP1,0x97			; porwnanie TMP1 z 0x97
	brlo ADC0297			; gdy mniejsze to skok do ADC0297
	cpi TMP1,0xF1			; porwnanie TMP1 z 0xF1
	brlo ADC02F1			; gdy mniejsze to skok do ADC02F1
ADC034B:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x0E			; odjcie 0x0E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x08			; wpisanie 0x08 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x03			; odjcie 0x03 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x34			; wpisanie 0x34 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x22			; odjcie 0x22 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	jmp ADCHUN				; skok do ADCHUN
ADC02F1:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x0E			; odjcie 0x0E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x07			; wpisanie 0x07 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x02			; odjcie 0x02 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x34			; wpisanie 0x34 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x22			; odjcie 0x22 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC0297:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x0E			; odjcie 0x0E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	dec DATA				; zmniejszenie DATA o 1
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x34			; wpisanie 0x34 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x22			; odjcie 0x22 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC034BI:
	nop
	nop
	jmp ADC034B				; skok do ADC034B
ADCH03:
	cpi TMP1,0x4B			; porwnanie TMP1 z 0x4B
	brlo ADC034BI			; gdy mniejsze to skok do ADC034BI
	cpi TMP1,0xA5			; porwnanie TMP1 z 0xA5
	brlo ADC03A5			; gdy mniejsze to skok do ADC03A5
	cpi TMP1,0xFF			; porwnanie TMP1 z 0xFF
	brlo ADC03FF			; gdy mniejsze to skok do ADC03FF
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x0E			; odjcie 0x0E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi DATA,0x36			; wpisanie 0x36 DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x06			; odjcie 0x06 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x34			; wpisanie 0x34 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x22			; odjcie 0x22 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC03FF:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x0E			; odjcie 0x0E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x0A			; wpisanie 0x0A do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x05			; odjcie 0x05 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x34			; wpisanie 0x34 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x22			; odjcie 0x22 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	nop
	jmp ADCHUN				; skok do ADCHUN
ADC03A5:
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x89			; odjcie 0x89 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x0E			; odjcie 0x0E od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x09			; wpisanie 0x09 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x04			; odjcie 0x04 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x34			; wpisanie 0x34 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x22			; odjcie 0x22 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	nop
	jmp ADCHUN				; skok do ADCHUN
;
TX_ON:
	ldi DATA,0x8E			; wpisanie 0x8E do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x3A			; odejmowanie 0x3A od DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi TMP1,0x6C			; wpisanie 0x6C do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	subi DATA,0x6A			; odejmowanie 0x6A od DATA
	call LCD_DATA			; wysanie DATA do LCD
	subi DATA,0x36			; odejmowanie 0x36 od DATA
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	call LCD_DATA			; wysanie DATA do LCD
	cbi ADMUX,0				; zerowanie bitu 0 rejestru ADMUX - ustawianie ADC0
	cbi ADMUX,1				; zerowanie bitu 1 rejestru ADMUX
	rcall READ_ADC			; odczyt woltomierza
;************************************************
	clr TMPL1				; zerowanie TMPL1
	clr TMPL2				; zerowanie TMPL2
	clr TMPL3				; zerowanie TMPL3
	ldi YL,0x6A				; wpisanie 0x6A do YL
	clr YH					; wyzerowanie YH
	ld TMPL4,Y+				; wpisanie danej SRAM spod adresu Y do TMPL4 i zwikszenie Y o 1
	ld TMPL5,Y				; wpisanie danej SRAM spod adresu Y do TMPL5
	ldi TMP1,0xE9			; wpisanie 0xE9 do TMP1
	mul TMPL4,TMP1			; mnoenie TMPL4 przez TMP1
	mov TMPL1,RL			; przepisanie RL do TMPL1
	mov TMPL2,RH			; przepisanie RH do TMPL2
	mul TMPL5,TMP1			; mnoenie TMPL5 przez TMP1
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMPL3,RH			; dodanie RH i C do TMPL3
	ldi TMP1,0x03			; wpisanie 0x03 do TMP1
	mul TMPL4,TMP1			; mnoenie TMPL4 przez TMP1
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMPL3,RH			; dodanie RH i C do TMPL3
	mul TMPL5,TMP1			; mnoenie TMPL5 przez TMP1
	add TMPL3,RL			; dodanie RL do TMPL3
	clc						; zerowanie flagi C
	ror TMPL3				; rotowanie TMPL3 przez Carry
	ror TMPL2				; rotowanie TMPL2 przez Carry
	clc						; zerowanie flagi C
	ror TMPL3				; rotowanie TMPL3 przez Carry
	ror TMPL2				; rotowanie TMPL2 przez Carry
	mov TMP1,TMPL2			; przepisanie TMPL2 do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brge TX_1BL				; gdy wiksze lub rwne to skok do 	brge TX_1BL
	mov TMPL1,TMP1			; przepisanie TMP1 do TMPL1 
	nop
	nop
	nop
	nop
	rjmp TX_1BLE			; skok do TX_1BLE
TX_1BL:
	mov TMPL1,TMP1			; przepisanie TMP1 do TMPL1
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	nop
	nop
	nop
TX_1BLE:
	mov TMP1,TMPL2			; przepisanie TMPL2 do TMP1
	swap TMP1				; zamiana czwrek bitw w TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brge TX_1BH				; gdy wiksze lub rwne to skok do 	brge TX_1BH
	mov TMPL2,TMP1			; przepisanie TMP1 do TMPL1 
	nop
	nop
	nop
	nop
	rjmp TX_1BHE			; skok do TX_1BHE
TX_1BH:
	mov TMPL2,TMP1			; przepisanie TMP1 do TMPL2
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	add TMPL2,TMP1			; dodanie TMP1 do TMPL2
	nop
	nop
	nop
TX_1BHE:
	ldi YL,0x6C				; wpisanie 0x6C do YL
	mov TMP1,TMPL1			; przepisanie TMPL1 do TMP1
	mov TMP2,TMPL1			; przepisanie TMPL1 do TMP2
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw
	swap TMP2				; zamiana czwrek bitw w TMP2
	andi TMP2,0x0F			; wyodrbnienie modszej czwrki bitw
	std Y+3,TMP1			; wpisanie TMP1 do SRAM po adres Y+3
	std Y+2,TMP2			; wpisanie TMP2 do SRAM po adres Y+2
	mov TMP3,TMP2			; przepisanie TMP2 do TMP3
	mov TMP1,TMPL2			; przepisanie TMPL2 do TMP1
	mov TMP2,TMPL2			; przepisanie TMPL2 do TMP2
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw
	swap TMP2				; zamiana czwrek bitw w TMP2
	andi TMP2,0x0F			; wyodrbnienie modszej czwrki bitw
	add TMP3,TMP1			; dodanie TMP1 do TMP3
	std Y+2,TMP3			; wpisanie TMP3 do SRAM po adres Y+3
	ldi TMP4,0x06			; wpisanie 0x06 do TMP4
	mul TMP1,TMP4			; mnoenie TMP1 przez TMP4
	ldd TMP1,Y+3			; wpisanie danej SRAM spod adresu Y+3 do TMP1
	add TMP1,RL				; dodanie RL do TMP1
	std Y+3,TMP1			; wpisanie TMP1 do SRAM po adres Y+3
	std Y+1,TMP2			; wpisanie TMP2 do SRAM pod adres Y+1
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM spod adresu Y+2
	mul TMP2,TMP4			; mnoenie TMP2 przez TMP4
	add TMP1,RL				; dodawanie RL do TMP1
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ldd TMP1,Y+3			; wpisanie do TMP1 danej SRAM spod adresu Y+3
	ldi TMP4,0x06			; wpisanie 0x06 do TMP4
	mul TMPL3,TMP4			; mnoenie TMPL3 przez TMP4
	add TMP1,RL				; dodanie RL do TMP1
	std Y+3,TMP1			; wpisanie TMP1 do SRAM pod adres Y+3
	ldi TMP4,0x05			; wpisanie 0x05 do TMP4
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM spod adresu Y+2
	mul TMPL3,TMP4			; mnoenie TMPL3 przez TMP4
	add TMP1,RL				; dodanie RL do TMP1
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ldi TMP4,0x02			; wpisanie 0x02 do TMP4
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM spod adresu Y+1
	mul TMPL3,TMP4			; mnoenie TMPL3 przez TMP4
	add TMP1,RL				; dodanie RL do TMP1
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres Y+1
;************************************************
	ldi YL,0x6C				; wpisanie 0x6C do YL
	ldd TMP1,Y+3			; wpisanie do TMP1 danej SRAM spod adresu Y+3
	clr TMP2				; wyzerowanie TMP2
TX_JE1:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo TX_JE				; gdy mniejsze to skok do TX_JE
	subi TMP1,0x0A			; odejmowanie 0x0A od TMP1
	inc TMP2				; zwikszenie TMP2 o 1
	nop
	nop
	rjmp TX_JE1				; skok do TX_JE1
TX_JE:
	std Y+3,TMP1			; wpisanie TMP1 do SRAM pod adres Y+3
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM spod adresu Y+2
	add TMP1,TMP2			; dodanie TMP2 do TMP1
	clr TMP2				; wyzerowanie TMP2
	nop
	nop
	nop
	nop
	nop
	nop
	nop
TX_JE2:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo TX_JE3				; gdy mniejsze to skok do TX_JE3
	subi TMP1,0x0A			; odejmowanie 0x0A od TMP1
	inc TMP2				; zwikszenie TMP2 o 1
	nop
	nop
	rjmp TX_JE2				; skok do TX_JE2
TX_JE3:
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM spod adresu Y+1
	add TMP1,TMP2			; dodanie TMP2 do TMP1
	clr TMP2				; wyzerowanie TMP2
	nop
	nop
	nop
	nop
	nop
	nop
	nop
TX_JE4:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo TX_JE5				; gdy mniejsze to skok do TX_JE5
	subi TMP1,0x0A			; odejmowanie 0x0A od TMP1
	inc TMP2				; zwikszenie TMP2 o 1
	nop
	nop
	rjmp TX_JE4				; skok do TX_JE4
TX_JE5:
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres Y+1
	st Y,TMP2				; wpisanie danej TMP2 do SRAM pod adresu Y
;************************************************
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	ldi YL,0x6C				; wpisanie 0x6C do YL
	ldi DATA,0xC2			; wpisanie 0xC2 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	ld DATA,Y				; wpisanie do DATA danej SRAM spod adresu Y
	sbrc TMP4,0				; pomi nastpn instrukcj gdy TMP4 bit 0 rwny 0
	rjmp TX_WR1				; skok do TX_WR1
TX_WR1E:
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
TX_WR1E1:
	call LCD_DATA			; wysanie do LCD
	ldd DATA,Y+1			; wpisanie do DATA danej SRAM spod adresu Y+1
	sbrc TMP4,0				; pomi nastpn instrukcj gdy TMP4 bit 0 rwny 0
	rjmp TX_WR2				; skok do TX_WR2	
TX_WR2E:
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
TX_WR2E2:
	call LCD_DATA			; wysanie do LCD
	ldd DATA,Y+2			; wpisanie do DATA danej SRAM spod adresu Y+2
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie do LCD
	ldi DATA,0x2E			; wpisanie 0x2E do DATA
	call LCD_DATA			; wysanie do LCD
	ldd DATA,Y+3			; wpisanie do DATA danej SRAM spod adresu Y+3
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wysanie do LCD
	ldi DATA,0x20			; wpisanie 0x20 do DATA
	call LCD_DATA			; wysanie DATA do LCD
	ldi DATA,0x25			; wpisanie 0x25 do DATA
	call LCD_DATA			; wysanie do LCD
	cbi PORTB,PB0
	nop			; dodane by byo n*8+1
	ret
TX_WR1:
	cpi DATA,0x00			; porwnanie DATA do 0x00
	brne TX_WR1N			; gdy rne to skok do TX_WR1N
	ldi DATA,0x20			; wpisanie 0x20 do DATA
	nop
	nop
	nop
	nop
	rjmp TX_WR1E1			; skok do TX_WR1E1
TX_WR1N:
	clr TMP4				; wyzerowanie TMP4
	nop
	rjmp TX_WR1E			; skok do TX_WR1E
TX_WR2:
	cpi DATA,0x00			; porwnanie DATA do 0x00
	brne TX_WR2N			; gdy rne to skok do TX_WR2N
	ldi DATA,0x20			; wpisanie 0x20 do DATA
	nop
	nop
	nop
	nop
	rjmp TX_WR2E2			; skok do TX_WR2E2
TX_WR2N:
	clr TMP4				; wyzerowanie TMP4
	nop
	rjmp TX_WR2E			; skok do TX_WR2E
;
DATA2LCD:
; wypisanie czstotliwoci na LCD
	call LCD_INSTR			; wysanie DATA do LCD
	ldi YL,0x96				; wpisanie 0x96 do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	subi TMP4,0x03			; odjcie 0x03 od TMP4
	ldi TMP3,0x01			; wpisanie 0x01 do TMP3
D2L_LOOP:
	nop
	nop
	nop
	nop
	nop
	ld DATA,Y+				; wpisanie do DATA danej SRAM spod adresu Y i zwikszenie Y o 1
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	sbrc TMP3,0				; pominicie nastpnej instrukcji gdy bit 0 TMP3 jest wyzerowany
	rjmp CHECK_0			; skok do CHECK_0
	nop
	add DATA,TMP1			; dodanie TMP1 do DATA
CHECK_00:
	rcall LCD_DATA			; wysanie DATA do LCD
	dec TMP4				; zmniejszenie TMP4 o 1
	brne D2L_LOOP			; gdy TMP2 rne od zera to skok do D2L_LOOP				
	ld DATA,Y+				; wpisanie do DATA danej SRAM spod adresu Y i zwikszenie Y o 1
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	rcall LCD_DATA			; wysanie DATA do LCD
	ldi DATA,0x2E			; wpisanie 0x2E do DATA
	rcall LCD_DATA			; wysanie DATA do LCD
	ld DATA,Y+				; wpisanie do DATA danej SRAM spod adresu Y i zwikszenie Y o 1
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	rcall LCD_DATA			; wysanie DATA do LCD
	ld DATA,Y+				; wpisanie do DATA danej SRAM spod adresu Y i zwikszenie Y o 1
	ldi TMP1,0x30			; wpisanie 0x30 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	rcall LCD_DATA			; wysanie DATA do LCD
	nop
	nop
	nop
	nop
	ret
CHECK_0:
	nop
	nop
	nop
	cpi DATA,0x00			; porwnanie DATA z 0x00
	brne CHECK_0N			; gdy rne to skok do CHECK_0N
	ldi DATA,0x20			; wpisanie 0x20 do DATA
	nop
	rjmp CHECK_00			; skok do CHECK_00
CHECK_0N:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	clr TMP3				; wyzerowanie TMP3
	add DATA,TMP1			; dodanie TMP1 do DATA
	rjmp CHECK_00			; skok do CHECK_00
;
BIT2DEC:
; konwersja trjbajtowych ( + 1 bit) liczb binarnych do dziesitnych
; najmodszy bajt jest w SRAMie dany adresem w Z
; miejsce zapisu w SRAMie jest dane  adresem w Y
	ldi YL,0x70				; wpisanie 0x70 do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	nop
	nop
	nop
	nop
	nop
; ***********************************************************************************
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw TMP1
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A (dziesitnie 10)
	brlo B2H_00				; gdy mniejszy to skok do B2H_00
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	rjmp B2H_01				; skok do B2H_01
B2H_00:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	nop			
	nop		
; ***********************************************************************************
B2H_01:
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw TMP1
	swap TMP1				; zamiana czwrek bitw w TMP1
	nop		
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A (dziesitnie 10)
	brlo B2H_02				; gdy mniejszy to skok do B2H_02
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	rjmp B2H_03				; skok do B2H_03
B2H_02:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	nop			
	nop		
B2H_03:
	adiw Z,0x01				; zwikszenie Z 0 1
; ***********************************************************************************
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw TMP1
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A (dziesitnie 10)
	brlo B2H_10				; gdy mniejszy to skok do B2H_10
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	rjmp B2H_11				; skok do B2H_11
B2H_10:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	nop			
	nop		
; ***********************************************************************************
B2H_11:
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw TMP1
	swap TMP1				; zamiana czwrek bitw w TMP1
	nop		
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A (dziesitnie 10)
	brlo B2H_12				; gdy mniejszy to skok do B2H_12
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	rjmp B2H_13				; skok do B2H_13
B2H_12:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	nop			
	nop		
B2H_13:
	adiw Z,0x01				; zwikszenie Z 0 1
; ***********************************************************************************
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw TMP1
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A (dziesitnie 10)
	brlo B2H_20				; gdy mniejszy to skok do B2H_20
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	rjmp B2H_21				; skok do B2H_21
B2H_20:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	nop			
	nop		
; ***********************************************************************************
B2H_21:
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw TMP1
	swap TMP1				; zamiana czwrek bitw w TMP1
	nop		
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A (dziesitnie 10)
	brlo B2H_22				; gdy mniejszy to skok do B2H_22
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	rjmp B2H_23				; skok do B2H_23
B2H_22:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop			
	nop			
	nop		
B2H_23:
	adiw Z,0x01				; zwikszenie Z o 1
; ***********************************************************************************
	nop
	ld TMP1,Z				; wpisanie bajtu SRAM o adresie w Z do TMP1
	cpi TMP1,0x00			; porwnanie TMP1 do 0x00
	breq B2H_24				; gdy rwne to skok do B2H_24
	ldi TMP1,0x01			; wpisanie 0x01 do TMP1
	rjmp B2H_25				; skok do B2H_25
B2H_24:
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	nop
B2H_25:
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres Y i zwikszenie Y o 1
	nop
	nop
	nop
	nop
	nop
	nop
; ***********************************************************************************
; przeksztacenie HEX do BYTE
	ldi YL,0x70				; wpisanie 0x80 do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	nop
	nop
	nop
	nop
	nop
	nop
	ld TMP1,Y				; wpisanie do TMP1 danej SRAM spod adresu Y
	std Y+16, TMP1			; wpisanie TMP1 pod adres SRAM Y+16
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM o adresie Y+1
	std Y+17,TMP1			; wpisanie TMP1 do SRAM pod adres Y+17
	ldd TMP1,Y+3			; wpisanie do TMP1 danej SRAM spod adresu Y+3
	std Y+18,TMP1			; wpisanie TMP1 do SRAM pod adres Y+18
	ldd TMP2,Y+2			; wpisanie do TMP2 danej SRAM spod adresu Y+2
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+16			; wpisanie TMP1 do SRAM pod adres Y+16
	add TMP1,RL				; dodanie RL do TMP1	
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
H2B_00:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo H2B_01				; gdy mniejsze to skok do H2B_01
	inc TMP3				; zwikszenie TMP3 o 1
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	nop						
	nop						
	rjmp H2B_00				; skok do H2B_00
H2B_01:
	nop
	nop
	std Y+16,TMP1			; wpisanie TMP1 do SRAM pod adres Y+16
	ldd TMP1,Y+17			; wpisanie do TMP1 danej SRAM spod adresu Y+17
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+17,TMP1			; wpisanie TMP1 do SRAM pod adres Y+17
	ldd TMP2,Y+3			; wpisanie do TMP2 danej SRAM spod adresu Y+3
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+17			; wpisanie do TMP1 danej SRAM spod adresu Y+17
	add TMP1,RL				; dodanie RL do TMP1
	ldd TMP3,Y+2			; wpisanie do TMP3 danej SRAM spod adresu Y+2
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
H2B_02:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo H2B_03				; gdy mniejsze to skok do H2B_03
	inc TMP3				; zwikszenie TMP3 o 1
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	nop						
	nop						
	rjmp H2B_02				; skok do H2B_02
H2B_03:
	nop			
	std Y+17,TMP1			; wpisanie TMP1 do SRAM pod adres Y+17
	ldd TMP1,Y+18			; wpisanie do TMP1 danej SRAM spod adresu Y+18
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+18,TMP1			; wpisanie TMP1 do SRAM pod adres Y+18
	ldd TMP1,Y+4			; wpisanie do TMP1 danej SRAM spod adresu Y+4
	std Y+19, TMP1			; wpisanie TMP1 do SRAM pod adres Y+19
	ldd TMP1,Y+5			; wpisanie do TMP1 danej SRAM spod adresu Y+5
	std Y+20,TMP1			; wpisanie TMP1 do SRAM pod adres Y+20
	ldd TMP1,Y+7			; wpisanie do TMP1 danej SRAM spod adresu Y+7
	std Y+21,TMP1			; wpisanie TMP1 do SRAM pod adres Y+21
	ldd TMP2,Y+6			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+19			; wpisanie do TMP1 danej SRAM spod adresu Y+19
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
H2B_10:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo H2B_11				; gdy mniejsze to skok do H2B_11
	inc TMP3				; zwikszenie TMP3 o 1
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	nop						
	nop						
	rjmp H2B_10				; skok do H2B_10
H2B_11:
	nop			
	nop			
	std Y+19,TMP1			; wpisanie TMP1 do SRAM pod adres Y+19
	ldd TMP1,Y+20			; wpisanie do TMP1 danej SRAM spod adresu Y+20
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+20,TMP1			; wpisanie TMP1 do SRAM pod adres Y+20
	ldd TMP2,Y+7			; wpisanie do TMP1 danej SRAM spod adresu Y+7
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+20			; wpisanie do TMP1 danej SRAM spod adresu Y+20
	add TMP1,RL				; dodanie RL do TMP1
	ldd TMP3,Y+6			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
H2B_12:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo H2B_13				; gdy mniejsze to skok do H2B_13
	inc TMP3				; zwikszenie TMP3 o 1
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	nop						
	nop						
	rjmp H2B_12				; skok do H2B_12
H2B_13:
	nop			
	std Y+20,TMP1			; wpisanie TMP1 do SRAM pod adres Y+20
	ldd TMP1,Y+21			; wpisanie do TMP1 danej SRAM spod adresu Y+21
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+21,TMP1			; wpisanie TMP1 do SRAM pod adres Y+21
	ldd TMP1,Y+8			; wpisanie do TMP1 danej SRAM spod adresu Y+8
	std Y+22,TMP1			; wpisanie TMP1 do SRAM pod adres Y+22
	ldd TMP1,Y+9			; wpisanie do TMP1 danej SRAM spod adresu Y+9
	std Y+23,TMP1			; wpisanie TMP1 do SRAM pod adres Y+23
	ldd TMP1,Y+11			; wpisanie do TMP1 danej SRAM spod adresu Y+11
	std Y+24,TMP1			; wpisanie TMP1 do SRAM pod adres Y+24
	ldd TMP2,Y+10			; wpisanie do TMP1 danej SRAM spod adresu Y+10
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+22			; wpisanie do TMP1 danej SRAM spod adresu Y+22
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
H2B_20:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo H2B_21				; gdy mniejsze to skok do H2B_21
	inc TMP3				; zwikszenie TMP3 o 1
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	nop						
	nop						
	rjmp H2B_20				; skok do H2B_20
H2B_21:
	nop			
	nop			
	std Y+22,TMP1			; wpisanie TMP1 do SRAM pod adres Y+22
	ldd TMP1,Y+23			; wpisanie do TMP1 danej SRAM spod adresu Y+23
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+23,TMP1			; wpisanie TMP1 do SRAM pod adres Y+23
	ldd TMP2,Y+11			; wpisanie do TMP1 danej SRAM spod adresu Y+11
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+23			; wpisanie do TMP1 danej SRAM spod adresu Y+23
	add TMP1,RL				; dodanie RL do TMP1
	ldd TMP3,Y+10			; wpisanie do TMP1 danej SRAM spod adresu Y+10
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
H2B_22:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo H2B_23				; gdy mniejsze to skok do H2B_23
	inc TMP3				; zwikszenie TMP3 o 1
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	nop						
	nop						
	rjmp H2B_22				; skok do H2B_22
H2B_23:
	nop			
	std Y+23,TMP1			; wpisanie TMP1 do SRAM pod adres Y+23
	ldd TMP1,Y+24			; wpisanie do TMP1 danej SRAM spod adresu Y+24
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+24,TMP1			; wpisanie TMP1 do SRAM pod adres Y+24
	ldd TMP1,Y+12			; wpisanie do TMP1 danej SRAM spod adresu Y+11
	std Y+25,TMP1			; wpisanie TMP1 do SRAM pod adres Y+25
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	std Y+26,TMP1			; wpisanie TMP1 do SRAM pod adres Y+26
	std Y+27,TMP1			; wpisanie TMP1 do SRAM pod adres Y+27
	nop
	nop
	nop
	nop
	nop
	nop
	nop
; koniec przeksztacenia HEX do BYTE
; ***********************************************************************************
; przeksztacenie 2*BYTE do WORD
	nop
	nop
	nop
	ldi YL,0x80				; wpisanie 0x80 do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	ld TMP1,Y				; wpisanie do TMP1 danej SRAM spod adresu Y
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM spod adresu Y+1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM spod adresu Y+2
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP2,Y+3			; wpisanie do TMP2 danej SRAM spod adresu Y+3
	clc						; zerowanie flagi C
	rol TMP2				; rotowanie bitw w lewo w TMP2
	add TMP2,TMP1			; dodanie TMP1 do TMP2
	std Y+14,TMP2			; wpisanie TMP2 do SRAM pod adres Y+14
	ldd TMP2,Y+4			; wpisanie do TMP2 danej SRAM spod adresu Y+4
	clc						; zerowanie flagi C
	rol TMP2				; rotowanie bitw w lewo w TMP2
	std Y+15,TMP2			; wpisanie TMP2 do SRAM pod adres Y+15
	ldd TMP2,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	clc						; zerowanie flagi C
	rol TMP2				; rotowanie bitw w lewo w TMP2
	std Y+16,TMP2			; wpisanie TMP2 do SRAM pod adres Y+16
	ldi TMP2,0x06			; wpisanie 0x06 do TMP2
	ldd TMP1,Y+3			; wpisanie do TMP2 danej SRAM spod adresu Y+3
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+12			; wpisanie do TMP1 danej SRAM spod adresu Y+12
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
B2W_00:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo B2W_01				; gdy mniejsze to skok do B2W_01
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp B2W_00				; skok do B2W_00
B2W_01:
	nop
	nop
	nop
	nop
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+4			; wpisanie do TMP1 danej SRAM spod adresu Y+4
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+3			; wpisanie do TMP2 danej SRAM spod adresu Y+3
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
B2W_02:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo B2W_03				; gdy mniejsze to skok do B2W_03
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp B2W_02				; skok do B2W_02
B2W_03:
	nop
	nop
	nop
	nop
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP1,Y+4			; wpisanie do TMP1 danej SRAM spod adresu Y+4
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,RL				; dodanie RL do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldi TMP2,0x06			; wpisanie 0x06 do TMP2
	ldd TMP1,Y+5			; wpisanie do TMP1 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
B2W_04:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo B2W_05				; gdy mniejsze to skok do B2W_05
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp B2W_04				; skok do B2W_04
B2W_05:
	nop
	nop
	nop
	nop
	nop
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP1,Y+15			; wpisanie do TMP1 danej SRAM spod adresu Y+15
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+15			; wpisanie do TMP1 danej SRAM spod adresu Y+15
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
B2W_06:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo B2W_07				; gdy mniejsze to skok do B2W_07
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp B2W_06				; skok do B2W_06
B2W_07:
	nop
	nop
	nop
	nop
	nop
	nop
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldd TMP1,Y+16			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+16,TMP1			; wpisanie TMP1 do SRAM pod adres Y+16
	ldd TMP1,Y+6			; wpisanie do TMP2 danej SRAM spod adresu Y+6
	std Y+17,TMP1			; wpisanie TMP1 do SRAM pod adres Y+17
	ldd TMP1,Y+7			; wpisanie do TMP2 danej SRAM spod adresu Y+7
	std Y+18,TMP1			; wpisanie TMP1 do SRAM pod adres Y+18
	ldd TMP1,Y+8			; wpisanie do TMP2 danej SRAM spod adresu Y+8
	std Y+19,TMP1			; wpisanie TMP1 do SRAM pod adres Y+19
	ldd TMP2,Y+9			; wpisanie do TMP2 danej SRAM spod adresu Y+9
	clc						; zerowanie flagi C
	rol TMP2				; rotowanie bitw w lewo w TMP2
	add TMP2,TMP1			; dodanie TMP1 do TMP2
	std Y+19,TMP2			; wpisanie TMP2 do SRAM pod adres Y+19
	ldd TMP2,Y+10			; wpisanie do TMP2 danej SRAM spod adresu Y+10
	clc						; zerowanie flagi C
	rol TMP2				; rotowanie bitw w lewo w TMP2
	std Y+20,TMP2			; wpisanie TMP2 do SRAM pod adres Y+20
	ldd TMP2,Y+11			; wpisanie do TMP2 danej SRAM spod adresu Y+11
	clc						; zerowanie flagi C
	rol TMP2				; rotowanie bitw w lewo w TMP2
	std Y+21,TMP2			; wpisanie TMP2 do SRAM pod adres Y+21
	ldi TMP2,0x06			; wpisanie 0x06 do TMP2
	ldd TMP1,Y+9			; wpisanie do TMP2 danej SRAM spod adresu Y+9
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+17			; wpisanie do TMP1 danej SRAM spod adresu Y+17
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
B2W_08:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo B2W_09				; gdy mniejsze to skok do B2W_09
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp B2W_08				; skok do B2W_08
B2W_09:
	nop
	nop
	nop
	nop
	nop
	std Y+17,TMP1			; wpisanie TMP2 do SRAM pod adres Y+20
	ldd TMP1,Y+18			; wpisanie do TMP1 danej SRAM spod adresu Y+18
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+18,TMP1			; wpisanie TMP1 do SRAM pod adres Y+18
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+9			; wpisanie do TMP2 danej SRAM spod adresu Y+9
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+18			; wpisanie do TMP1 danej SRAM spod adresu Y+18
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
B2W_10:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo B2W_11				; gdy mniejsze to skok do B2W_11
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp B2W_10				; skok do B2W_10
B2W_11:
	std Y+18,TMP1			; wpisanie TMP1 do SRAM pod adres Y+18
	ldd TMP1,Y+19			; wpisanie do TMP1 danej SRAM spod adresu Y+19
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+19,TMP1			; wpisanie TMP1 do SRAM pod adres Y+19
	nop
; koniec przeksztacenia 2*BYTE do WORD
; ***********************************************************************************
; przeksztacenie WORD do DECIMAL
	nop
	nop
	nop
	ldi YL,0x8C				; wpisanie 0x8C do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	ld TMP1,Y				; wpisanie do TMP1 danej SRAM spod adresu Y
	std Y+17,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM spod adresu Y+1
	std Y+16,TMP1			; wpisanie TMP1 do SRAM pod adres Y+16
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM spod adresu Y+2
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldd TMP1,Y+3			; wpisanie do TMP1 danej SRAM spod adresu Y+3
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP1,Y+4			; wpisanie do TMP1 danej SRAM spod adresu Y+4
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldi TMP2,0x06			; wpisanie 0x06 do TMP2
	ldd TMP1,Y+8			; wpisanie do TMP2 danej SRAM spod adresu Y+8
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	std Y+10,RL				; wpisanie RL do SRAM pod adres Y+10
	ldd TMP1,Y+7			; wpisanie do TMP2 danej SRAM spod adresu Y+7
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	std Y+11,RL				; wpisanie RL do SRAM pod adres Y+11
	ldd TMP1,Y+6			; wpisanie do TMP2 danej SRAM spod adresu Y+6
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	std Y+12,RL				; wpisanie RL do SRAM pod adres Y+12
	ldd TMP1,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP3 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+17			; wpisanie do TMP1 danej SRAM spod adresu Y+17
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_00:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_01				; gdy mniejsze to skok do W2D_01
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_00				; skok do W2D_00
W2D_01:
	nop
	nop
	nop
	nop
	std Y+17,TMP1			; wpisanie TMP1 do SRAM pod adres Y+17
	ldd TMP1,Y+16			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+16,TMP1			; wpisanie TMP1 do SRAM pod adres Y+16
	ldd TMP1,Y+6			; wpisanie do TMP2 danej SRAM spod adresu Y+6
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+16			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,RL				; dodanie RL do TMP1
	std Y+16,TMP1			; wpisanie TMP1 do SRAM pod adres Y+16
	ldi TMP2,0x03			; wpisanie 0x03 do TMP2
	ldd TMP1,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+16			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_02:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_03				; gdy mniejsze to skok do W2D_03
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_02				; skok do W2D_02
W2D_03:
	nop
	nop
	std Y+16,TMP1			; wpisanie TMP1 do SRAM pod adres Y+16
	ldd TMP1,Y+15			; wpisanie do TMP1 danej SRAM spod adresu Y+15
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldd TMP1,Y+6			; wpisanie do TMP2 danej SRAM spod adresu Y+6
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+15			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,RL				; dodanie RL do TMP1
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+15			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,RL				; dodanie RL do TMP1
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldi TMP2,0x06			; wpisanie 0x06 do TMP2
	ldd TMP1,Y+7			; wpisanie do TMP2 danej SRAM spod adresu Y+7
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+15			; wpisanie do TMP1 danej SRAM spod adresu Y+16
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_04:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_05				; gdy mniejsze to skok do W2D_05
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_04				; skok do W2D_04
W2D_05:
	nop
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres Y+15
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP1,Y+8			; wpisanie do TMP2 danej SRAM spod adresu Y+8
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,RL				; dodanie RL do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+5			; wpisanie do TMP2 danej SRAM spod adresu Y+5
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,RL				; dodanie RL do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP1,Y+6			; wpisanie do TMP2 danej SRAM spod adresu Y+6
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,RL				; dodanie RL do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldi TMP2,0x03			; wpisanie 0x03 do TMP2
	ldd TMP1,Y+7			; wpisanie do TMP2 danej SRAM spod adresu Y+7
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+14			; wpisanie do TMP1 danej SRAM spod adresu Y+14
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_06:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_07				; gdy mniejsze to skok do W2D_07
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_06				; skok do W2D_06
W2D_07:
	nop
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres Y+14
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+8			; wpisanie do TMP2 danej SRAM spod adresu Y+8
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+6			; wpisanie do TMP2 danej SRAM spod adresu Y+6
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+7			; wpisanie do TMP2 danej SRAM spod adresu Y+7
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldi TMP2,0x06			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+9			; wpisanie do TMP2 danej SRAM spod adresu Y+9
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+13			; wpisanie do TMP1 danej SRAM spod adresu Y+13
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_08:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_09				; gdy mniejsze to skok do W2D_09
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_08				; skok do W2D_08
W2D_09:
	nop
	nop
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres Y+13
	ldd TMP1,Y+12			; wpisanie do TMP1 danej SRAM spod adresu Y+12
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+7			; wpisanie do TMP2 danej SRAM spod adresu Y+7
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+12			; wpisanie do TMP1 danej SRAM spod adresu Y+12
	add TMP1,RL				; dodanie RL do TMP1
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldd TMP1,Y+8			; wpisanie do TMP2 danej SRAM spod adresu Y+8
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+12			; wpisanie do TMP1 danej SRAM spod adresu Y+12
	add TMP1,RL				; dodanie RL do TMP1
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldi TMP2,0x03			; wpisanie 0x03 do TMP2
	ldd TMP1,Y+9			; wpisanie do TMP2 danej SRAM spod adresu Y+9
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+12			; wpisanie do TMP1 danej SRAM spod adresu Y+12
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_10:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_11				; gdy mniejsze to skok do W2D_11
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_10				; skok do W2D_10
W2D_11:
	nop
	nop
	nop
	nop
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres Y+12
	ldd TMP1,Y+11			; wpisanie do TMP1 danej SRAM spod adresu Y+11
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+11,TMP1			; wpisanie TMP1 do SRAM pod adres Y+11
	ldi TMP2,0x05			; wpisanie 0x05 do TMP2
	ldd TMP1,Y+8			; wpisanie do TMP2 danej SRAM spod adresu Y+8
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+11			; wpisanie do TMP1 danej SRAM spod adresu Y+11
	add TMP1,RL				; dodanie RL do TMP1
	std Y+11,TMP1			; wpisanie TMP1 do SRAM pod adres Y+11
	ldd TMP1,Y+9			; wpisanie do TMP2 danej SRAM spod adresu Y+9
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Y+11			; wpisanie do TMP1 danej SRAM spod adresu Y+11
	add TMP1,RL				; dodanie RL do TMP1
	ldi TMP3,0x00			; wpisanie 0x00 do TMP3
W2D_12:
	cpi TMP1,0x0A			; porwnanie TMP1 z 0x0A
	brlo W2D_13				; gdy mniejsze to skok do W2D_13
	subi TMP1,0x0A			; odjcie 0x0A od TMP1
	inc TMP3				; zwikszenie TMP3 o 1
	nop
	nop
	rjmp W2D_12				; skok do W2D_12
W2D_13:
	std Y+11,TMP1			; wpisanie TMP1 do SRAM pod adres Y+11
	ldd TMP1,Y+10			; wpisanie do TMP1 danej SRAM spod adresu Y+10
	add TMP1,TMP3			; dodanie TMP3 do TMP1
	std Y+10,TMP1			; wpisanie TMP1 do SRAM pod adres Y+10
	nop
	nop
	nop
	nop
	nop
	ret
;
ODJ:
; odejmowanie binarne liczb trjbajtowych z SRAM
	ldi XL,0x60				; wpisanie 0x60 do XL
	ldi XH,0x00				; wpisanie 0x00 do XH
	ld TMP1,X+				; wpisanie do TMP1 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMP2,X+				; wpisanie do TMP2 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMP3,X+				; wpisanie do TMP3 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMPL1,X+				; wpisanie do TMPL1 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMPL2,X+				; wpisanie do TMPL2 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMPL3,X+				; wpisanie do TMPL3 danej SRAM spod adresu X i zwikszenie go o 1
	clc						; wyzerowanie flagi C
	cp TMP3,TMPL3			; porwnanie TMP3 z TMPL3
	brsh ODJ_GE3			; skok do ODJ_GE3 gdy TMP3>=TMPL3
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	rjmp ODJ_REV			; skok do ODJ_REV
ODJ_EQ3:
	clc						; wyzerowanie flagi C
	cp TMP2,TMPL2			; porwnanie TMP2 z TMPL2
	brsh ODJ_GE2			; skok do ODJ_GE2 gdy TMP2>=TMPL2
	rjmp ODJ_REV			; skok do ODJ_REV
ODJ_EQ2:
	clc						; wyzerowanie flagi C
	cp TMP1,TMPL1			; porwnanie TMP1 z TMPL1
	brsh ODJ_NORM1			; skok do ODJ_NORM1 gdy TMP1>=TMPL1
	nop
	rjmp ODJ_REV			; skok do ODJ_REV
ODJ_GE3:
	cp TMP3,TMPL3			; porwnanie TMP3 z TMPL3
	breq ODJ_EQ3			; skok do ODJ_EQ3 gdy TMP3=TMPL3
	nop
	rjmp ODJ_NORM			; skok do ODJ_NORM
ODJ_GE2:
	cp TMP2,TMPL2			; porwnanie TMP2 z TMPL2
	breq ODJ_EQ2			; skok do ODJ_EQ2 gdy TMP2=TMPL2
	nop
	nop
	rjmp ODJ_NORM			; skok do ODJ_NORM
ODJ_REV:
; odejmowanie odwrotne TMPLi-TMPi
	clc						; wyzerowanie flagi C
	sbc TMPL1,TMP1			; odjcie TMP1 od TMPL1
	sbc TMPL2,TMP2			; odjcie TMP2 od TMPL2
	sbc TMPL3,TMP3			; odjcie TMP3 od TMPL3
	mov TMP3,TMPL3			; wpisanie TMPL3 do TMP3
	mov TMP2,TMPL2			; wpisanie TMPL2 do TMP2
	mov TMP1,TMPL1			; wpisanie TMPL1 do TMP1
	rjmp ODJ_END			; skok do ODJ_END
ODJ_NORM1:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
ODJ_NORM:
; normalne odejmowanie TMPi-TMPLi
	clc						; wyzerowanie flagi C
	sbc TMP1,TMPL1			; odjcie TMPL1 od TMP1
	sbc TMP2,TMPL2			; odjcie TMPL2 od TMP2
	sbc TMP3,TMPL3			; odjcie TMPL3 od TMP3
ODJ_END:
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres z X i zwikszenie X o 1
	st X+,TMP2				; wpisanie TMP2 do SRAM pod adres z X i zwikszenie X o 1
	st X+,TMP3				; wpisanie TMP3 do SRAM pod adres z X i zwikszenie X o 1
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres z X i zwikszenie X o 1
	ldi DATA,0xCF			; wpisanie 0xCF do DATA
	call LCD_INSTR			; wypisanie na LCD
	ldi DATA,0x2D			; wpisanie 0x2D do DATA
	call LCD_DATA			; wypisanie na LCD
	nop
	nop			; dodane by byo n*8+1
	ret
;
SUM:
; sumowanie binarne liczb trjbajtowych z SRAM
	ldi XL,0x60				; wpisanie 0x60 do XL
	ldi XH,0x00				; wpisanie 0x00 do XH
	ld TMP1,X+				; wpisanie do TMP1 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMP2,X+				; wpisanie do TMP2 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMP3,X+				; wpisanie do TMP3 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMPL1,X+				; wpisanie do TMPL1 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMPL2,X+				; wpisanie do TMPL2 danej SRAM spod adresu X i zwikszenie go o 1
	ld TMPL3,X+				; wpisanie do TMPL3 danej SRAM spod adresu X i zwikszenie go o 1
	clr TMP4				; wyzerowanie TMP4
	clc						; wyzerowanie flagi C
	add TMP1,TMPL1			; sumowanie TMP1 i TMPL1
	adc TMP2,TMPL2			; sumowanie TMP2 i TMPL2
	adc TMP3,TMPL3			; sumowanie TMP3 i TMPL3
	brcs SUM_OVR			; gdy C=1 to skok do SUM_OVR
	rjmp SUM_END			; skok do SUM_END
SUM_OVR:
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
SUM_END:
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres X i zwikszenie X o 1
	st X+,TMP2				; wpisanie TMP2 do SRAM pod adres X i zwikszenie X o 1
	st X+,TMP3				; wpisanie TMP3 do SRAM pod adres X i zwikszenie X o 1
	st X+,TMP4				; wpisanie TMP4 do SRAM pod adres X i zwikszenie X o 1
	ldi DATA,0xCF			; wpisanie 0xCF do DATA
	call LCD_INSTR			; wypisanie na LCD
	ldi DATA,0x2B			; wpisanie 0x2B do DATA
	call LCD_DATA			; wypisanie na LCD
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop			; dodany aby n*8+1
	ret
;
READ_DATA:
; procedura czytania danych z buforw i wpisywania ich do SRAMu
	ldi TMP1,0xF8			; wpisanie 0xF8 do TMP1
	out PORTA,TMP1			; wpisanie TMP1 do PORTA
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ldi XH,0x00				; wyzerowanie bajtu MSB licznika X
	ldi XL,0x60				; wpisanie 0x60 do bajtu LSB licznika X
	cbi PORTA,PA7			; wyzerowanie bitu PA7
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in TMP1,PINC			; wpisanie PINC do TMP1
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres X i zwikszenie X o 1
	sbi PORTA,PA7			; ustawienie bitu PA7
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	cbi PORTA,PA6			; wyzerowanie bitu PA6
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in TMP1,PINC			; wpisanie PINC do TMP1
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres X i zwikszenie X o 1
	sbi PORTA,PA6			; ustawienie bitu PA6
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	st X+,LICZA				; wpisanie LICZA do SRAM pod adres X i zwikszenie X o 1
	cbi PORTA,PA4			; wyzerowanie bitu PA4
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in TMP1,PINC			; wpisanie PINC do TMP1
	nop
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres X i zwikszenie X o 1
	sbi PORTA,PA4			; ustawienie bitu PA4
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	cbi PORTA,PA5			; wyzerowanie bitu PA5
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in TMP1,PINC			; wpisanie PINC do TMP1
	nop
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres X i zwikszenie X o 1
	sbi PORTA,PA5			; ustawienie PA5
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
;***********************
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	st X+,LICZB				; wpisanie LICZB do SRAM pod adres X i zwikszenie X o 1
	nop
	nop
	nop
	nop			; dodane n*8+1
	ret
;
DELAY40us:
; ptla opniajca dokadnie 40 us (640 cykli)
	ldi D1,0x05				; wpisanie 0x05 do D1
	ldi D2,0x29				; wpisanie 0x29 do D2
	mov TMP1,D1				; przepisanie D1 do TMP1
DEL40_1:
	mov TMP2,D2				; przepisanie D2 do TMP2
DEL40_2:
	dec TMP2				; zmniejszenie TMP1 o 1
	brne DEL40_2			; gdy rne od zera to skok do DEL40_2
	dec TMP1
	brne DEL40_1			; gdy rne od zera to skok do DEL40_1
	nop
	ret
;						; 									4
DELAY100us:
; ptla opniajca dokadnie 100 us (1600 cykli)
	nop
	ldi D1, 0x01			; wpisanie 0x03 do D1
	ldi D2, 0x06			; wpisanie 0xFB do D2
	ldi D3, 0x57			; wpisanie 0x1C do D3
	rjmp DEL				; skok do DEL
DELAY2ms:
; ptla opniajca dokadnie 2 ms (32000 cykli)
	nop
	nop
	ldi D1,0x4B				; wpisanie 0x16 do D1
DEL2m:
	dec D1					; zmniejszenie D1 o 1
	brne DEL2m				; gdy D1 rne od zera to skok do DEL2m
	ldi D1, 0x03			; wpisanie 0x03 do D1
	ldi D2, 0x7E			; wpisanie 0x7E do D2
	ldi D3, 0x1B			; wpisanie 0x1B do D3
	rjmp DEL				; skok do DEL
DELAY4_1ms:
; ptla opniajca dokadnie 4.1 ms (65600 cykli)
	nop
	nop
	ldi D1,0x16				; wpisanie 0x16 do D1
DEL4_1:
	dec D1					; zmniejszenie D1 o 1
	brne DEL4_1				; gdy D1 rne od zera to skok do DEL4_1
	ldi D1, 0x03			; wpisanie 0x03 do D1
	ldi D2, 0xFB			; wpisanie 0xFB do D2
	ldi D3, 0x1C			; wpisanie 0x1C do D3
	rjmp DEL				; skok do DEL
DELAY15ms:
; ptla opniajca dokadnie 15 ms (240000 cykli)
	ldi D1,0x14				; wpisanie 0x14 do D1
DEL15:
	dec D1					; zmniejszenie D1 o 1
	brne DEL15				; gdy D1 rne od zera to skok do DEL15
	ldi D1,0x08				; wpisanie 0x08 do D1
	ldi D2, 0xEE			; wpisanie 0xEE do D2
	ldi D3, 0x29			; wpisanie 0x29 do D3
	rjmp DEL				; skok do DEL
DELAY2s:
; ptla opniajca okoo ~2 s
	ldi D1,0xC1				; wpisanie 0x08 do D1
	ldi D2,0xFF				; wpisanie 0xEE do D2
	ldi D3,0xFF				; wpisanie 0x29 do D3
	rjmp DEL				; skok do DEL
DEL:
	mov TMP1, D1			; przepisz D1 do TMP1
DEL1:
	mov TMP2, D2			; przepisz D2 do TMP2
DEL2:
	mov TMP3, D3			; przepisz D3 do TMP3
DEL3:
	dec TMP3				; zmniejsz TMP3 o 1
	brne DEL3				; gdy TMP3 rne od 0 to id do DEL3
	dec TMP2				; zmniejsz TMP2 o 1
	brne DEL2				; gdy TMP2 rne od 0 to id do DEL2
	dec TMP1				; zmniejsz TMP1 o 1
	brne DEL1				; gdy TMP1 rne od 0 to id do DEL1
	ret
;
LCD_DATA:					; 									4
	sbi PORTB,PB3			; ustawianie pinu 2 Portu C (RS)	2
	nop
	nop
	nop
	nop
	nop
	nop
LCD_INSTR:
	call LCD_INSTR4			; wylij 4 starsze bity instrukcji
	call LCD_INSTR4			; wylij 4 modsze bity instrukcji
	call DELAY40us
	cbi PORTB,PB3			; zerowanie pinu 2 Portu C (RS)		2
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;						; 									4
LCD_INSTR4:					;									4
	mov TMP1,DATA			; przepisanie DATA do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw
	in TMP2,PINB			; przepisanie PORTC do TMP2
	andi TMP2,0x0F			; wyodrbnienie modszej czwrki bitw
	or TMP1,TMP2			; sumowanie logiczne TMP1 i TMP2
	out PORTB,TMP1			; wysanie TMP1 do Portu C
	nop
	sbi PORTB,PB2			; ustaw E wywietlacza
	swap DATA				;				2 
	nop
	nop
	nop
	cbi PORTB,PB2			; wyzeruj E wywietlacza			2
	nop
	ret
;
LCD_INIT:
; incjalizacja wywietlacza LCD
; PB0 - przeczanie TX(VCC) lub RX(GND)
; PB1 - R/W LCD
; PB2 - E LCD
; PB3 - RS LCD
; PB4 - bit danej LCD(LSB)
; PB5 - bit danej LCD		MOSI
; PB6 - bit danej LCD		MISO
; PB7 - bit danej LCD(MSB)	SCK
	rcall DELAY15ms
	in TMP1,PORTB			; wpisanie PORTB do TMP1
	andi TMP1,0x01			; wyodrbnienie najmodszego bitu TMP1
	ori TMP1,0x30			; suma logiczna TMP1 i 0x30
	out PORTB,TMP1			; przepisanie TMP1 do PORTB
	rcall DELAY4_1ms
	sbi PORTB,PB2			; ustawienie bitu 2 w Porcie B (E)
	cbi PORTB,PB2			; wyzerowanie bitu 2 w Porcie B (E)
	rcall DELAY100us
	sbi PORTB,PB2			; ustawienie bitu 2 w Porcie B (E)
	cbi PORTB,PB2			; wyzerowanie bitu 2 w Porcie B (E)
	rcall DELAY100us
	sbi PORTB,PB2			; ustawienie bitu 2 w Porcie B (E)
	cbi PORTB,PB2			; wyzerowanie bitu 2 w Porcie B (E)
	cbi PORTB,PB4			; wyzerowanie bitu 4 w Porcie B (dana 0010)
	rcall DELAY100us
	sbi PORTB,PB2			; ustawienie bitu 2 w Porcie B (E)
	cbi PORTB,PB2			; wyzerowanie bitu 2 w Porcie B (E)
	ldi DATA,0x28			; wpisanie 0x28 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	ldi DATA,0x0C			; wpisanie 0x0C do DATA (0x0F z migajcym kursorem, 0x0C bez migania)
	call LCD_INSTR			; wysanie DATA do LCD
	ldi DATA,0x06			; wpisanie 0x06 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	ldi DATA,0x01			; wpisanie 0x01 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	rcall DELAY2ms
	rcall DELAY2ms
	ldi DATA,0x20			; wpisanie 0x20 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x24			; wpisanie 0x24 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x05			; wpisanie 0x05 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x02			; odejmowanie 0x02 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x02			; wpisanie 0x02 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x0B			; wpisanie 0x0B do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x13			; odejmowanie 0x13 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x0B			; wpisanie 0x0B do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x2C			; odejmowanie 0x2C od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x33			; wpisanie 0x33 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x10			; odejmowanie 0x10 od DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x02			; odejmowanie 0x02 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x0B			; wpisanie 0x0B do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x07			; odejmowanie 0x07 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x7C			; wpisanie 0x7C do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_INSTR			; wypisanie na LCD
	subi DATA,0x5F			; odejmowanie 0x5F od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x17			; wpisanie 0x17 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x59			; odejmowanie 0x59 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x33			; wpisanie 0x33 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x03			; odejmowanie 0x03 od DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x1B			; odejmowanie 0x1B od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x14			; wpisanie 0x14 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x04			; wpisanie 0x04 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	inc DATA				; zwikszenie DATA o 1
	inc DATA				; zwikszenie DATA o 1
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x29			; odejmowanie 0x29 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x31			; wpisanie 0x31 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	inc DATA				; zwikszenie DATA o 1
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x25			; odejmowanie 0x25 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x23			; wpisanie 0x23 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	rcall DELAY2s
	ldi DATA,0x01			; wpisanie 0x01 do DATA
	call LCD_INSTR			; wysanie DATA do LCD
	rcall DELAY2ms
	rcall DELAY2ms
	ldi DATA,0x85			; wpisanie 0x85 do DATA
	call LCD_INSTR			; wypisanie na LCD
	subi DATA,0x55			; odejmowanie 0x55 od DATA
	call LCD_DATA			; wypisanie na LCD
	dec DATA				; zmniejszenie DATA o 1
	dec DATA				; zmniejszenie DATA o 1
	call LCD_DATA			; wypisanie na LCD
	inc DATA				; zwikszenie DATA o 1
	inc DATA				; zwikszenie DATA o 1
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x10			; odejmowanie 0x10 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x4B			; wpisanie 0x4B do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x23			; odejmowanie 0x23 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x32			; wpisanie 0x32 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x5A			; odejmowanie 0x5A od DATA
	call LCD_DATA			; wypisanie na LCD
	sbic PINB,PB0			; przeskocz instrukcj gdy PB0=0
	rjmp LCD_TX				; skok do LCD_TX
	ldi DATA,0x52			; wpisanie 0x52 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x06			; wpisanie 0x06 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x68			; wpisanie 0x68 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_INSTR			; wypisanie na LCD
	subi DATA,0x6D			; odejmowanie 0x6D od DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x33			; odejmowanie 0x33 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x10			; wpisanie 0x10 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x10			; odejmowanie 0x10 od DATA
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
LCD_RXTX:
	rcall MODE				; wywoanie procedury MODE
	ldi DATA,0xCF
	call LCD_INSTR			; wypisanie na LCD
	sbis PINB,PINB0			; pominicie nastpnej instrukcji gdy PINB0=1
	ldi DATA,0x2D			; wpisanie 0x2D do DATA
	nop
	sbic PINB,PINB0			; pominicie nastpnej instrukcji gdy PINB0=0
	ldi DATA,0x2B			; wpisanie 0x2B do DATA
	nop
	call LCD_DATA			; wypisanie na LCD
	ret
LCD_TX:
	ldi DATA,0x54			; wpisanie 0x54 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x04			; wpisanie 0x04 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x68			; wpisanie 0x68 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_INSTR			; wypisanie na LCD
	subi DATA,0x6A			; odejmowanie 0x6A od DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x36			; odejmowanie 0x36 od DATA
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x10			; wpisanie 0x10 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x02			; odejmowanie 0x02 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x02			; wpisanie 0x02 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x10			; odejmowanie 0x10 od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x05			; wpisanie 0x05 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x05			; odejmowanie 0x05 od DATA
	call LCD_DATA			; wypisanie na LCD
	rjmp LCD_RXTX			; skok do LCD_RXTX
;
MODE:
; sprawdzanie rodzaju ustawionej emisji i typisywanie tego na LCD
; oraz wpisanie czstotliwoci p.cz. dla emisji AM i FM
	sbis PIND,PIND7			; pominicie nastpnej instrukcji gdy PIND7=1
	rcall AMFM				; wywoanie procedury wypisania modu AM/FM na LCD i wpisania czstotliwoci poredniej dla AM/FM
	nop
	nop
	sbic PIND,PIND7			; pominicie nastpnej instrukcji gdy PIND7=0
	rcall SSBCW				; wywoanie procedury wypisania modu SSB/CW na LCD
	nop
	nop			; n*8+1
	ret
;
AMFM:
; procedura wypisania modu AM/FM na LCD i wpisania czstotliwoci poredniej dla AM/FM
	ldi DATA,0xCB			; wpisanie 0xCB do DATA
	call LCD_INSTR			; wypisanie na LCD
	sbis PIND,PIND4			; pominicie nastpnej instrukcji gdy PIND4=1
	rjmp FM_FM				; skok do FM_FM
	nop
	subi DATA,0xAB			; odejmowanie 0xAB od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x21			; wpisanie 0x21 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x0C			; wpisanie 0x0C do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	nop
	nop
AMFM_END:
	rcall DEC2BIN			; wywoanie procedury DEC2BIN
	nop
	nop			; n*8+1
	ret
FM_FM:
; procedura wypisania modu FM na LCD i wpisania czstotliwoci poredniej dla FM
	subi DATA,0xAB			; odejmowanie 0xAB od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x26			; wpisanie 0x26 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x07			; wpisanie 0x07 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	rjmp AMFM_END			; skok do AMFM_END
SSBCW:
; procedura wypisania modu SSB/CW na LCD
	ldi DATA,0xCB			; wpisanie 0xCB do DATA
	call LCD_INSTR			; wypisanie na LCD
	sbis PIND,PIND4			; pominicie nastpnej instrukcji gdy PIND4=1
	rjmp CW_CW				; skok do CW_CW
	nop
	subi DATA,0x78			; odejmowanie 0x78 od DATA
	call LCD_DATA			; wypisanie na LCD
	call LCD_DATA			; wypisanie na LCD
	subi DATA,0x11			; odejmowanie 0x11 od DATA
	call LCD_DATA			; wypisanie na LCD
	nop
	nop
	nop
	nop
	nop
SSBCW_END:
	nop
	nop
	nop			; n*8+1
	ret
CW_CW:
; wywoanie procedury wypisania modu CW na LCD
	subi DATA,0xAB			; odejmowanie 0xAB od DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x23			; wpisanie 0x23 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	ldi TMP1,0x14			; wpisanie 0x14 do TMP1
	add DATA,TMP1			; dodanie TMP1 do DATA
	call LCD_DATA			; wypisanie na LCD
	rjmp SSBCW_END			; skok do SSBCW_END
;
DEC2BIN:
; procedura przepisania danych z Flasha (od adresu 0x3FFC),
; ich konwersja na posta binarn i wpisanie do SRAMu (od adresu 0x0063)
; maksymalna liczba dziesitna z Flasha nie moe przekracza liczby 16777216 (4-ry bajty)
; wynik binarny konwersji musi pomieci si w 3-ch bajtach
	ldi XH,0x00				; wpisanie 0x00 do XH
	ldi XL,0x63				; wpisanie 0x63 do XL
	clr TMP1				; wyzerowanie TMP1
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres z X i zwikszenie X o 1
	st X+,TMP1				; wpisanie TMP1 do SRAM pod adres z X i zwikszenie X o 1
	st X,TMP1				; wpisanie TMP1 do SRAM pod adres z X
	ldi TMP2,0x0A			; wpisanie 0x0A do TMP2
	clr TMPL1				; zerowanie TMPL1
	clr TMPL2				; zerowanie TMPL2
	clr TMPL3				; zerowanie TMPL3
	clr TMPL4				; zerowanie TMPL4
	clr TMPL5				; zerowanie TMPL5
	ldi ZH,0x3F				; wpisanie 0x3F do ZH
	ldi ZL,0xFC				; wpisanie 0xFC do ZL
	clr TMP3				; wyzerowanie rejestru TMP3 (RE)
	lpm						; odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0xF0			; wyodrbnienie 4-ch najstarszych bitw TMP1
	swap TMP1				; zamiana czwrek bitw w bajcie
	clc						; wyzerowanie flagi C
	adc TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przepenienia do TMPL2 (TMPL5=0x00)
	adc TMPL3,TMPL5			; dodanie przepenienia do TMPL3 (TMPL5=0x00)
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mov TMPL1,RL			; przepisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	nop
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR1		; gdy rne to skok do DEC2BIN_ERROR1
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
	lpm
	lpm
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw z TMP1
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR1		; gdy C=1 to skok do DEC2BIN_ERROR1
	adiw Z,0x01				; zwikszenie Z o 1
	nop
	clr TMP3				; wyzerowanie TMP3
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mov TMPL1,RL			; wpisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR1		; gdy rne to skok do DEC2BIN_ERROR1
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
	nop
	nop
	lpm
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw z TMP1
	swap TMP1
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR1		; gdy C=1 to skok do DEC2BIN_ERROR1
	clr TMP3				; wyzerowanie TMP3
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mov TMPL1,RL			; wpisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	mul TMPL3,TMP2
	nop
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR1		; gdy rne to skok do DEC2BIN_ERROR1
	rjmp DEC2BIN_1
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
DEC2BIN_ERROR1:
	nop
	rjmp DEC2BIN_ERROR
DEC2BIN_1:
	nop
	lpm
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw z TMP1
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR1		; gdy C=1 to skok do DEC2BIN_ERROR1
	adiw Z,0x01				; zwikszenie Z o 1
	clr TMP3				; wyzerowanie TMP3
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mov TMPL1,RL			; wpisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	nop
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR1		; gdy rne to skok do DEC2BIN_ERROR1
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
	nop
	nop
	lpm
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw z TMP1
	swap TMP1				; zamiana czwrek bitw w bajcie
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR1		; gdy C=1 to skok do DEC2BIN_ERROR1
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mul TMPL1,TMP2
	mov TMPL1,RL			; przepisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	mul TMPL2,TMP2
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR1		; gdy rne to skok do DEC2BIN_ERROR1
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
	nop
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw z TMP1
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR		; gdy C=1 to skok do DEC2BIN_ERROR1
	adiw Z,0x01				; zwikszenie Z o 1
	nop
	clr TMP3				; wyzerowanie TMP3
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mov TMPL1,RL			; wpisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR		; gdy rne to skok do DEC2BIN_ERROR
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
	mul TMPL3,TMP2
	lpm
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0xF0			; wyodrbnienie starszej czwrki bitw z TMP1
	swap TMP1				; zamiana czwrek bitw w bajcie
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR		; gdy C=1 to skok do DEC2BIN_ERROR
	mul TMPL1,TMP2			; mnoenie TMPL1 przez TMP2
	mul TMPL1,TMP2
	mov TMPL1,RL			; przepisanie RL do TMPL1
	mov TMP3,RH				; przepisanie RH do TMP3
	mul TMPL2,TMP2			; mnoenie TMPL2 przez TMP2
	mul TMPL2,TMP2
	clc						; wyzerowanie flagi Carry
	mov TMPL2,TMP3			; wpisanie TMP3 do TMPL2
	clr TMP3				; wyzerowanie TMP3
	add TMPL2,RL			; dodanie RL do TMPL2
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	mul TMPL3,TMP2			; mnoenie TMPL3 przez TMP2
	clc						; zerowanie flagi Carry
	mov TMPL3,TMP3			; wpisanie TMP3 do TMPL3
	clr TMP3				; wyzerowanie TMP3
	add TMPL3,RL			; dodanie RL do TMPL3
	adc TMP3,RH				; dodanie RH do TMP3 z Carry
	cpi TMP3,0x00			; porwnanie TMP3 z 0x00
	brne DEC2BIN_ERROR		; gdy rne to skok do DEC2BIN_ERROR
; gdy TMP3 rne od zera to zakres zosta przekroczony (granica zakresu to 0xFFFFFF czyli 16777215)
	lpm
	lpm
	lpm						; ponowny odczyt bajtu z Flasha
	mov TMP1,RL				; przepisanie RL do TMP1
	andi TMP1,0x0F			; wyodrbnienie modszej czwrki bitw z TMP1
	clc						; zerowanie flagi Carry
	add TMPL1,TMP1			; dodanie TMP1 do TMPL1
	adc TMPL2,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	adc TMPL3,TMPL5			; dodanie przeniesienia poprzedniego dodawania
	brcs DEC2BIN_ERROR		; gdy C=1 to skok do DEC2BIN_ERROR
	mul TMPL3,TMP2
	nop
	rjmp DEC2BIN_END			; skok do DEC2BIN_END
DEC2BIN_ERROR:
	ldi TMP1,0xFF			; wpisanie 0xFF do TMP1
	mov TMPL1,TMP1			; przepisanie TMP1 do TMPL1
	mov TMPL2,TMP1			; przepisanie TMP1 do TMPL2
	mov TMPL3,TMP1			; przepisanie TMP1 do TMPL3
DEC2BIN_END:
	ldi XH,0x00				; wpisanie 0x00 do XH
	ldi XL,0x63				; wpisanie 0x63 do XL
	st X+,TMPL1				; wpisanie TMPL1 do SRAM pod adres z X i zwikszenie X o 1
	st X+,TMPL2				; wpisanie TMPL2 do SRAM pod adres z X i zwikszenie X o 1
	st X,TMPL3				; wpisanie TMPL3 do SRAM pod adres z X
; **********************************************
	nop			; n*8+1
	ret
;
READ_ADC:
	sbi ADCSRA,6			; uruchamianie przetwarzania (ADSC=1)
R1_ADC:
	nop
	nop
	nop
	nop
	nop
	sbis ADCSRA,4			; gdy ADIF=1 to przeskok nastpnej instrukcji
	jmp R1_ADC				; skok do R1_ADC
	sbi ADCSRA,4			; ustawianie (wyzerowanie) ADIF
	in TMP1,ADCL			; przepisanie wyniku pomiaru (modszy bajt) do TMP1
	in TMP2,ADCH			; przepisanie wyniku pomiaru (starszy bajt) do TMP2
	ldi YL,0x6A				; wpisanie 0x6A do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres z Y i zwikszenie Y o 1 (LSB)
	st Y+,TMP2				; wpisanie TMP2 do SRAM pod adres z Y i zwikszenie Y o 1 (MSB)
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;
INIT_ADC:
; inicjalizacja przetwornika ADC
	ldi TMP1, 0xC1			; 1100 0000 REFS1:0=3 (wczone wewntrzne rdo odniesienia),
	out ADMUX, TMP1			; ADLAR=0, MUX4:0=1 (wczone wejcie ADC0)
	ldi TMP1, 0x87			; 1000 0111 ADEN=1 (wczenie ukadu ADC)
	out ADCSRA, TMP1		; ADPS2:0=3 (f/128)
	ret
;
TIMER1_INIT:
	ldi TMP1,0x00
	out TCNT1H,TMP1			; zerowanie licznika
	out TCNT1L,TMP1			;	Timer/Counter 1
	out OCR1AH,OCAH			; wpisz czas wypisywania wyniku
	out OCR1AL,OCAL			;	i zliczania do rejestru OCR1A
	ldi TMP1,0x80			; rejestr TCCR1A = 1000 0000
	out TCCR1A,TMP1			; tj. COM1A1:0=2, COM1B1:0=0, FOC1A = 0
	ldi TMP1,0x0C			; rejestr TCCR1B = 0000 1100
	out TCCR1B,TMP1			; tj.  WGM13:0=4, CS12:0=5
	ldi TMP1,0x10			; uaktywnij przerwanie
	out TIMSK,TMP1			;			OCIE1A
	ret
;
COEF:
; obliczenie wspczynnika poprawkowego czstotliwoci
; Wywoanie procedury korygujcej pomiar czstotliwoci
; Poprawna korekta jest moliwa jedynie dla generatorw o czstotliwociach
; lecych w zakresie od 2^23 do (2^24-1) [Hz] czyli od 8.388608 do 16.777215 [MHz]
; Czstotliwo nominalna zegara mikrokontrolera wynosi 16.000000 MHz
; i generator kwarcowy o zblionej czstotliwoci powinien by uyty.
	call BCD2BIN
	ldi YL,0x60				; wpisanie 0x60 do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	ld TMP1,Y				; wpisanie SRAM o adresie Y do TMP1
	std Y+12,TMP1			; wpisanie TMP1 do SRAMu pod adres Y+12
	ldd TMP1,Y+1			; wpisanie SRAM o adresie Y+1 do TMP1
	std Y+13,TMP1			; wpisanie TMP1 do SRAMu pod adres Y+13
	ldd TMP1,Y+2			; wpisanie SRAM o adresie Y+2 do TMP1
	std Y+14,TMP1			; wpisanie TMP1 do SRAMu pod adres Y+14
	ldd TMP1,Y+3			; wpisanie SRAM o adresie Y+3 do TMP1
	std Y+15,TMP1			; wpisanie TMP1 do SRAMu pod adres Y+15
	ldi TMP1,0x00			; wyzerowanie TMP1
	st Y,TMP1				; wpisanie TMP1 pod adres SRAM z Y
	std Y+1,TMP1			; wpisanie TMP1 pod adres SRAM z Y+1
	std Y+2,TMP1			; wpisanie TMP1 pod adres SRAM z Y+2
	std Y+3,TMP1			; wpisanie TMP1 pod adres SRAM z Y+3
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	std Y+8,TMP1			; wpisanie TMP1 pod adres SRAM z Y+8
	ldi TMP1,0x24			; wpisanie 0x24 do TMP1
	std Y+9,TMP1			; wpisanie TMP1 pod adres SRAM z Y+9
	ldi TMP1,0xF4			; wpisanie 0xF4 do TMP1
	std Y+10,TMP1			; wpisanie TMP1 pod adres SRAM z Y+10
	ldi TMP1,0x00			; wpisanie 0x00 do TMP1
	std Y+11,TMP1			; wpisanie TMP1 pod adres SRAM z Y+11
	ldi YL,0xB8				; wpisanie 0xB8 do YL
	ldi YH,0x00				; wpisanie 0x00 do YH
	ldi TMP1,0x00			; wyzerowanie TMP1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	st Y+,TMP1				; wpisanie TMP1 pod adres SRAM z Y i zwikszenie Y o 1
	ldi YL,0x6C				; wpisanie 0x6C do YL
	ldi YH,0x00				; wyzerowanie YH
	call ADJUST
	ldi YL,0x68				; wpisanie 0x68 do YL
	ldi YH,0x00				; wyzerowanie YH
	call ADJUST
	ldi D1,0x67				; wpisanie 0x67 do D1
	mov TMPL4,D1			; wpisanie D1 do TMPL4
	mov YL,TMPL4				; przepisanie D1 do YL
	ldi D2,0x00				; wpisanie 0x67 do D2
	mov YH,D2				; przepisanie D2 do YH
	ldi D1,0x31			; wpisanie 0x31 (49) do TMP5
	ldd TMP2,Y+4			; wpisanie do TMP2 bajtu SRAM o adresie Y+4 (MSB dzielnika)
	ldd TMP1,Y+8			; wpisanie do TMP1 bajtu SRAM o adresie Y+8 (MSB dzielnej)
COMPARIZON_E:
	ldd TMP2,Y+4			; wpisanie do TMP2 bajtu SRAM o adresie Y+3 (MSB dzielnika)
	ldd TMP1,Y+8			; wpisanie do TMP1 bajtu SRAM o adresie Y+7 (MSB dzielnej)
	cp TMP1,TMP2			; porwnanie TMP1 z TMP2
	brmi NEGATIVE			; gdy mniejszy TMP1 to skok do NEGATIVE
	cp TMP1,TMP2			; porwnanie TMP1 z TMP2
	breq EQUAL				; gdy rwne to skok do EQUAL
SUBTRACT:
;POSITIVE:
; dodatni wynik rnicy MSBs dzielnej i dzielnika
	call SUBTR
	call SET1				; wywoanie procedury SET1
	dec D1				; zmniejszenie TMP5 o 1
	cpi D1,0x00			; porwnanie TMP5 i 0x00
	brne CHECK				; gdy rwne to skok do CHECK
	rjmp COEF_END			; skok do COEF_END
NEGATIVE:
; ujemny wynik rnicy MSBs dzielnej i dzielnika
; Przesunicie dzielnej o jeden bit w lewo i zignorowanie przepenienia wystpujcego podczas odejmowania najstarszych bajtw.
	clc						; zerowanie flagi C
	dec D1				; zmniejszenie TMP5 o 1
	cpi D1,0x00			; porwnanie TMP5 ze sta 0x00
	brne NEG_NE				; gdy rne to skok do NEG_NE
	rjmp COEF_END			; skok do COEF_END
NEG_NE:
	clc						; wyzerowanie flagi C
	mov YL,TMPL4				; przepisanie D1 do YL
	mov YH,D2				; przepisanie D2 do YH
	ldd TMP1,Y+4			; wpisanie do TMP1 danej SRAM o adresie Y+4
	ror TMP1				; przesunicie w prawo o bit TMP1 
	std Y+4,TMP1			; wpisanie TMP1 do SRAM pod adres Y+4
	ldd TMP1, Y+3			; wpisanie do TMP1 danej SRAM o adresie Y+3
	ror TMP1				; przesunicie w prawo o bit TMP1
	std Y+3,TMP1			; wpisanie TMP1 do SRAM pod adres Y+3
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM o adresie Y+2
	ror TMP1				; przesunicie w prawo o bit TMP1
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM o adresie Y+1
	ror TMP1				; przesunicie w prawo o bit TMP1
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres Y+1
	call SUBTR				; wywanie procedury SUBTR
	clc						; wyzerowanie flagi C
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM o adresie Y+1
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres Y+1
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM o adresie Y+2
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ldd TMP1,Y+3			; wpisanie do TMP1 danej SRAM o adresie Y+3
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+3,TMP1			; wpisanie TMP1 do SRAM pod adres Y+3
	ldd TMP1,Y+4			; wpisanie do TMP1 danej SRAM o adresie Y+4
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+4,TMP1			; wpisanie TMP1 do SRAM pod adres Y+4
	call SET1				; wywoanie procedury SET1
	rjmp CHECK				; skok do CHECK
EQUAL:
; MSBs i dalsze bajty dzielnej i dzielnika s rwne
	sbiw Y,0x0001			; odjcie jedynki od Y
	mov TMP3,TMPL4				; przepisanie D1 do TMP3
	clc						; wyzerowanie flagi C
	sub TMP3,YL				; odjcie YL od TMP3
	cpi TMP3,0x03			; porwnwnie TMP3 z 0x03
	brge SUBTRACT			; gdy wiksze lub rwne to skok do subtract
	rjmp COMPARIZON_E		; skok do COMPARIZON_E
CHECK:
	ldd TMP1,Y+8			; wpisanie do TMP1 danej SRAM spod adresu Y+8
	cpi TMP1,0x00			; porwnanie TMP1 z 0x00
	brne CHECK_2			; gdy rne to skok do CHECK_2
	ldd TMP1,Y+7			; wpisanie do TMP1 danej SRAM spod adresu Y+7
	cpi TMP1,0x00			; porwnanie TMP1 z 0x00
	brne CHECK_2			; gdy rne to skok do CHECK_2
	ldd TMP1,Y+6			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	cpi TMP1,0x00			; porwnanie TMP1 z 0x00
	brne CHECK_2			; gdy rne to skok do CHECK_2
	ldd TMP1,Y+5			; wpisanie do TMP1 danej SRAM spod adresu Y+5
	cpi TMP1,0x00			; porwnanie TMP1 z 0x00
	brne CHECK_2			; gdy rne to skok do CHECK_2
	rjmp COEF_END			; skok do COEF_END
CHECK_2:
	clc						; wyzerowanie flagi C
	ldd TMP1,Y+8			; wpisanie do TMP1 danej SRAM spod adresu Y+8
	rol TMP1				; przesunicie w lewo o bit TMP1
	brcs COMPARIZON_EXT		; gdy C=1 to skok do COMPARIZON_EXT
	ldd TMP1,Y+5			; wpisanie do TMP1 danej SRAM spod adresu Y+5
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+5,TMP1			; wpisanie TMP1 do SRAM pod adres Y+5
	ldd TMP1,Y+6			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+6,TMP1			; wpisanie TMP1 do SRAM pod adres Y+6
	ldd TMP1,Y+7			; wpisanie do TMP1 danej SRAM spod adresu Y+7
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+7,TMP1			; wpisanie TMP1 do SRAM pod adres Y+7
	ldd TMP1,Y+8			; wpisanie do TMP1 danej SRAM spod adresu Y+8
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres Y+8
CHECK_IN:
	rol TMP1				; przesunicie w lewo o bit TMP1
	brcs COMPARIZON_EXT		; gdy C=1 to skok do COMPARIZON_EXT
	clc						; wezerowanie flagi C
	dec D1				; zmniejszenie TMP5 o 1
	cpi D1,0x00			; porwnanie TMP5 do staej 0x00
	breq COEF_END			; gdy rwne to skok do COEF_END
	ldd TMP1,Y+5			; wpisanie do TMP1 danej SRAM spod adresu Y+5
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+5,TMP1			; wpisanie TMP1 do SRAM pod adres Y+5
	ldd TMP1,Y+6			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+6,TMP1			; wpisanie TMP1 do SRAM pod adres Y+6
	ldd TMP1,Y+7			; wpisanie do TMP1 danej SRAM spod adresu Y+7
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+7,TMP1			; wpisanie TMP1 do SRAM pod adres Y+7
	ldd TMP1,Y+8			; wpisanie do TMP1 danej SRAM spod adresu Y+8
	rol TMP1				; przesunicie w lewo o bit TMP1
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres Y+8
	rjmp CHECK_IN			; skok do CHECK_IN
COMPARIZON_EXT:
	rjmp COMPARIZON_E		; skok do COMPARIZON_E
COEF_END:
	clr YL					; wyzerowanie YL
	clr YH					; wyzerowanie YH
	clr TMP1				; wyzerowanie TMP1
	clr TMP2				; wyzerowanie TMP2
	clr TMP3				; wyzerowanie TMP3
	clr TMP4				; wyzerowanie TMP4
;	clr TMP5				; wyzerowanie TMP5
	clr TMPL4					; wyzerowanie D1
	clr D1					; wyzerowanie D1
	clr D2					; wyzerowanie D2
	ret
;
BCD2BIN:
; Z licznik adresu Flash
	ldi ZL,0xF8				; ustawienie starszego bajtu adresu Z we flashu
	ldi ZH,0x3F				; ustawienie starszego bajtu adresu Z we flashu
	ldi YL,0x60				; ustawienie modszego bajtu adresu Y w SRAMie
	ldi YH,0x00				; ustawienie starszego bajtu adresu Y w SRAMie
	ldi TMP1,0x00			; wyzerowanie TMP1
	st Y,TMP1				; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+1,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+2,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+3,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+4,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+5,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+6,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+7,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+8,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+9,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+10,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+11,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+12,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+13,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+14,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	std Y+15,TMP1			; wyzerowanie SRAM o adresie w Y i zwikszenie Y o jeden
	ldi TMP4,0x08			; wpisanie 0x08 do TMP4 (liczba bajtw)
	mov TMP3,TMP4			; przepisanie TMP4 do TMP3
	dec TMP3				; zmniejszenie TMP3 o 1
BCD2BIN_1:
	lpm						; odcyztanie pojedzncyego bajtu y flasha
	mov D1,RL				; przepisanie RL do TMP5
	andi D1,0xF0			; wyodrbnienie starszej czwrki bitw
	swap D1				; zamiana czwrek bitw
	call ADD_BYTE
	ldi TMP2,0x0A			; mnonik (1 bajt)
	call MULTx1B
	dec TMP3				; zmniejszenie TMP3 o 1
	breq BCD2BIN_END		; gdy TMP3 rne od zera to skok do BCD2BIN_END
	lpm						; odcyztanie pojedzncyego bajtu y flasha
	mov D1,RL				; przepisanie RL do TMP5
	andi D1,0x0F			; wyodrbnienie modszej czwrki bitw
	call ADD_BYTE
	ldi TMP2,0x0A			; mnonik (1 bajt)
	call MULTx1B
	adiw Z,0x0001			; zwikszenie Z o 1
	dec TMP3				; zmniejszenie TMP3 o 1
	brne BCD2BIN_1			; gdy TMP3 rne od zera to skok do BCD2BIN_1
BCD2BIN_END:
	lpm						; odcyztanie pojedzncyego bajtu y flasha
	mov D1,RL				; przepisanie RL do TMP5
	andi D1,0x0F			; wyodrbnienie modszej czwrki bitw
	call ADD_BYTE
	ret
MULTx1B:
; mnoenie liczby TMP4-bajtowej przez jeden bajt
	ldi D3,0x00				; wyzerowanie D3
	mov D2,TMP4				; przepisanie TMP4 do D2
	mov TMPL5,YL			; przepisanie YL do TMPL5
	mov TMPL6,YH			; przepisanie YH do TMPL6
MULTx1B_1:
	ld TMP1,Y				; wpisanie SRAM spod adresy w Y do TMP1
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	add D3,RL				; dodanie RL do D3
	st Y+,D3				; wpisanie D3 do SRAM pod adres Y i zwikszenie Y o 1
	ldi D3,0x00				; wyzerowanie D3
	adc D3,RH				; dodanie RH i C do D3
	dec D2					; zmniejszenie D2 o 1
	brne MULTx1B_1			; gdy rne od zera to skok do MULTx1B_1
	mov YL,TMPL5			; przepisanie TMPL5 do YL
	mov YH,TMPL6			; przepisanie TMPL6 do YH
	ret
;
ADD_BYTE:
	clr TMPL6				; wyzerowanie TMPL6
;	ldi D1,0x00				; wyzerowanie D1
	mov TMPL5,YL			; przepisanie YL do TMPL5
	mov TMPL6,YH			; przepisanie YH do TMPL6
	mov D2,TMP4				; przepisanie TMP4 do D2
	dec D2					; zmniejszenie D2 o 1
	clc						; wyzerowanie flagi C
	ld TMP1,Y				; wpisanie SRAM spod adresu w Y do TMP1
	adc TMP1,D1			; dodanie TMP5 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres z Y i zwikszenie Y o 1
ADD_BYTE_1:
	ld TMP1,Y				; wpisanie SRAM spod adresu w Y do TMP1
	adc TMP1,TMPL6				; dodanie D1 do TMP1
	st Y+,TMP1				; wpisanie TMP1 do SRAM pod adres z Y i zwikszenie Y o 1
	dec D2					; zmniejszenie D2 o 1
	brne ADD_BYTE_1			; gdy D2 rne od zera to skok do ADD_BYTE_1
	mov YL,TMPL5			; przepisanie TMPL5 do YL
	mov YH,TMPL6			; przepisanie TMPL6 do YH
	ret
;
SUBTR:
; procedura odejmowania liczby czterobajtowej
; w SRAMie (Y+4 - Y+1) od liczby czterobajtowej w SRAMie (Y+8 - Y+5)
	mov YL,TMPL4				; przepisanie D1 do YL
	mov YH,D2				; przepisanie D2 do YH
	clr TMP4				; wyzerowanie TMP4
	ldd TMP1,Y+5			; wpisanie do TMP1 danej SRAM spod adresu Y+5
	ldd TMP2,Y+1			; wpisanie do TMP danej SRAM spod adresu Y+1
	clc						; wyzerowanie flagi C
	sub TMP1,TMP2			; odejmowanie TMP2 od TMP1
	brcc SUBT_00			; gdy C=0 to skok do SUBT_00
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	std Y+5,TMP1			; wpisanie TMP1 do SRAM pod adres Y+5
	ldd TMP1,Y+6			; wpisanie do TMP1 daneh SRAM o adresie Y+6
	sub TMP1,TMP4			; odjcie TMP4 od TMP1
	brcc SUBT_0				; gdy C=0 to skok do SUBT_0
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	std Y+6,TMP1			; wpisanie TMP1 do SRAM pod adres Y+6
	ldd TMP1,Y+7			; wpisanie do TMP1 daneh SRAM o adresie Y+7
	sub TMP1,TMP4			; odjcie TMP4 od TMP1
	brcc SUBT_0				; gdy C=0 to skok do SUBT_0
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	std Y+7,TMP1			; wpisanie TMP1 do SRAM pod adres Y+7
	ldd TMP1,Y+8			; wpisanie do TMP1 daneh SRAM o adresie Y+8
	sub TMP1,TMP4			; odjcie TMP4 od TMP1
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres Y+8
	rjmp SUBT_0				; skok do SUBT_0
SUBT_00:
	std Y+5,TMP1
SUBT_0:
	ldd TMP1,Y+6			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	ldd TMP2,Y+2			; wpisanie do TMP danej SRAM spod adresu Y+2
	clr TMP4				; wyzerowanie TMP4
	clc						; wyzerowanie flagi C
	sub TMP1,TMP2			; odejmowanie TMP2 od TMP1
	brcc SUBT_10			; gdy C=0 to skok do SUBT_10
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	std Y+6,TMP1			; wpisanie TMP1 do SRAM pod adres Y+6
	ldd TMP1,Y+7			; wpisanie do TMP1 daneh SRAM o adresie Y+7
	sub TMP1,TMP4			; odjcie TMP4 od TMP1
	brcc SUBT_1				; gdy C=0 to skok do SUBT_1
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	std Y+7,TMP1			; wpisanie TMP1 do SRAM pod adres Y+7
	ldd TMP1,Y+8			; wpisanie do TMP1 daneh SRAM o adresie Y+8
	sub TMP1,TMP4			; odjcie TMP4 od TMP1
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres Y+8
	rjmp SUBT_1				; skok do SUBT_1
SUBT_10:
	std Y+6,TMP1
SUBT_1:
	ldd TMP1,Y+7			; wpisanie do TMP1 danej SRAM spod adresu Y+6
	ldd TMP2,Y+3			; wpisanie do TMP danej SRAM spod adresu Y+2
	clr TMP4				; wyzerowanie TMP4
	clc						; wyzerowanie flagi C
	sub TMP1,TMP2			; odejmowanie TMP2 od TMP1
	brcc SUBT_20			; gdy C=0 to skok do SUBT_20
	ldi TMP4,0x01			; wpisanie 0x01 do TMP4
	std Y+7,TMP1			; wpisanie TMP1 do SRAM pod adres Y+7
	ldd TMP1,Y+8			; wpisanie do TMP1 daneh SRAM o adresie Y+8
	sub TMP1,TMP4			; odjcie TMP4 od TMP1
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres Y+8
	rjmp SUBT_2				; skok do SUBT_2
SUBT_20:
	std Y+7,TMP1
SUBT_2:
	ldd TMP1,Y+8			; wpisanie do TMP1 danej SRAM spod adresu Y+8
	ldd TMP2,Y+4			; wpisanie do TMP danej SRAM spod adresu Y+4
	clr TMP4				; wyzerowanie TMP4
	clc						; wyzerowanie flagi C
	sub TMP1,TMP2			; odejmowanie TMP2 od TMP1
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres Y+8
	ret
SET1:
; ustawienie 1 w odpowiednim bicie wyniku zgodnie z licznikiem bitw TMP5
	ldi XL,0xB8				; wpisanie 0xB8 do XL
	ldi XH,0x00				; wpisanie 0x00 do XH
	cpi D1,0x31			; czy TMP5 = 0x31
	brne EC_49				; nie to skok do EC_49
	rjmp E_49				; skok do E_49
EC_49:
	cpi D1,0x30			; czy TMP5 = 0x30
	brne EC_48				; nie to skok do EC_48
	rjmp E_48				; skok do E_48
EC_48:
	cpi D1,0x2F			; czy TMP5 = 0x2F
	brne EC_47				; nie to skok do EC_47
	rjmp E_47				; skok do E_47
EC_47:
	cpi D1,0x2E			; czy TMP5 = 0x2E
	brne EC_46				; nie to skok do EC_46
	rjmp E_46				; skok do E_46
EC_46:
	cpi D1,0x2D			; czy TMP5 = 0x2D
	brne EC_45				; nie to skok do EC_45
	rjmp E_45				; skok do E_45
EC_45:
	cpi D1,0x2C			; czy TMP5 = 0x2C
	brne EC_44				; nie to skok do EC_44
	rjmp E_44				; skok do E_44
EC_44:
	cpi D1,0x2B			; czy TMP5 = 0x2B
	brne EC_43				; nie to skok do EC_43
	rjmp E_43				; skok do E_43
EC_43:
	cpi D1,0x2A			; czy TMP5 = 0x2A
	brne EC_42				; nie to skok do EC_42
	rjmp E_42				; skok do E_42
EC_42:
	cpi D1,0x29			; czy TMP5 = 0x29
	brne EC_41				; nie to skok do EC_41
	rjmp E_41				; skok do E_41
EC_41:
	cpi D1,0x28			; czy TMP5 = 0x28
	brne EC_40				; nie to skok do EC_40
	rjmp E_40				; skok do E_40
EC_40:
	cpi D1,0x27			; czy TMP5 = 0x27
	brne EC_39				; nie to skok do EC_39
	rjmp E_39				; skok do E_39
EC_39:
	cpi D1,0x26			; czy TMP5 = 0x26
	brne EC_38				; nie to skok do EC_38
	rjmp E_38				; skok do E_38
EC_38:
	cpi D1,0x25			; czy TMP5 = 0x25
	brne EC_37				; nie to skok do EC_37
	rjmp E_37				; skok do E_37
EC_37:
	cpi D1,0x24			; czy TMP5 = 0x24
	brne EC_36				; nie to skok do EC_36
	rjmp E_36				; skok do E_36
EC_36:
	cpi D1,0x23			; czy TMP5 = 0x23
	brne EC_35				; nie to skok do EC_35
	rjmp E_35				; skok do E_35
EC_35:
	cpi D1,0x22			; czy TMP5 = 0x22
	brne EC_34				; nie to skok do EC_34
	rjmp E_34				; skok do E_34
EC_34:
	cpi D1,0x21			; czy TMP5 = 0x21
	brne EC_33				; nie to skok do EC_33
	rjmp E_33				; skok do E_33
EC_33:
	cpi D1,0x20			; czy TMP5 = 0x20
	brne EC_32				; nie to skok do EC_32
	rjmp E_32				; skok do E_32
EC_32:
	cpi D1,0x1F			; czy TMP5 = 0x1F
	brne EC_31				; nie to skok do EC_31
	rjmp E_31				; skok do E_31
EC_31:
	cpi D1,0x1E			; czy TMP5 = 0x1E
	brne EC_30				; nie to skok do EC_30
	rjmp E_30				; skok do E_30
EC_30:
	cpi D1,0x1D			; czy TMP5 = 0x1D
	brne EC_29				; nie to skok do EC_29
	rjmp E_29				; skok do E_29
EC_29:
	cpi D1,0x1C			; czy TMP5 = 0x1C
	brne EC_28				; nie to skok do EC_28
	rjmp E_28				; skok do E_28
EC_28:
	cpi D1,0x1B			; czy TMP5 = 0x1B
	brne EC_27				; nie to skok do EC_27
	rjmp E_27				; skok do E_27
EC_27:
	cpi D1,0x1A			; czy TMP5 = 0x1A
	brne EC_26				; nie to skok do EC_26
	rjmp E_26				; skok do E_26
EC_26:
	cpi D1,0x19			; czy TMP5 = 0x19
	brne EC_25				; nie to skok do EC_25
	rjmp E_25				; skok do E_25
EC_25:
	cpi D1,0x18			; czy TMP5 = 0x18
	brne EC_24				; nie to skok do EC_24
	rjmp E_24				; skok do E_24
EC_24:
	cpi D1,0x17			; czy TMP5 = 0x17
	brne EC_23				; nie to skok do EC_23
	rjmp E_23				; skok do E_23
EC_23:
	cpi D1,0x16			; czy TMP5 = 0x16
	brne EC_22				; nie to skok do EC_22
	rjmp E_22				; skok do E_22
EC_22:
	cpi D1,0x15			; czy TMP5 = 0x15
	brne EC_21				; nie to skok do EC_21
	rjmp E_21				; skok do E_21
EC_21:
	cpi D1,0x14			; czy TMP5 = 0x14
	brne EC_20				; nie to skok do EC_20
	rjmp E_20				; skok do E_20
EC_20:
	cpi D1,0x13			; czy TMP5 = 0x13
	brne EC_19				; nie to skok do EC_19
	rjmp E_19				; skok do E_19
EC_19:
	cpi D1,0x12			; czy TMP5 = 0x12
	brne EC_18				; nie to skok do EC_18
	rjmp E_18				; skok do E_18
EC_18:
	cpi D1,0x11			; czy TMP5 = 0x11
	brne EC_17				; nie to skok do EC_17
	rjmp E_17				; skok do E_17
EC_17:
	cpi D1,0x10			; czy TMP5 = 0x10
	brne EC_16				; nie to skok do EC_16
	rjmp E_16				; skok do E_16
EC_16:
	cpi D1,0x0F			; czy TMP5 = 0x0F
	brne EC_15				; nie to skok do EC_15
	rjmp E_15				; skok do E_15
EC_15:
	cpi D1,0x0E			; czy TMP5 = 0x0E
	brne EC_14				; nie to skok do EC_14
	rjmp E_14				; skok do E_14
EC_14:
	cpi D1,0x0D			; czy TMP5 = 0x0D
	brne EC_13				; nie to skok do EC_13
	rjmp E_13				; skok do E_13
EC_13:
	cpi D1,0x0C			; czy TMP5 = 0x0C
	brne EC_12				; nie to skok do EC_12
	rjmp E_12				; skok do E_12
EC_12:
	cpi D1,0x0B			; czy TMP5 = 0x0B
	brne EC_11				; nie to skok do EC_11
	rjmp E_11				; skok do E_11
EC_11:
	cpi D1,0x0A			; czy TMP5 = 0x0A
	brne EC_10				; nie to skok do EC_10
	rjmp E_10				; skok do E_10
EC_10:
	cpi D1,0x09			; czy TMP5 = 0x09
	brne EC_09				; nie to skok do EC_09
	rjmp E_09				; skok do E_09
EC_09:
	cpi D1,0x08			; czy TMP5 = 0x08
	brne EC_08				; nie to skok do EC_08
	rjmp E_08				; skok do E_08
EC_08:
	cpi D1,0x07			; czy TMP5 = 0x07
	brne EC_07				; nie to skok do EC_07
	rjmp E_07				; skok do E_07
EC_07:
	cpi D1,0x06			; czy TMP5 = 0x06
	brne EC_06				; nie to skok do EC_06
	rjmp E_06				; skok do E_06
EC_06:
	cpi D1,0x05			; czy TMP5 = 0x05
	brne EC_05				; nie to skok do EC_05
	rjmp E_05				; skok do E_05
EC_05:
	cpi D1,0x04			; czy TMP5 = 0x04
	brne EC_04				; nie to skok do EC_04
	rjmp E_04				; skok do E_04
EC_04:
	cpi D1,0x03			; czy TMP5 = 0x03
	brne EC_03				; nie to skok do EC_03
	rjmp E_03				; skok do E_03
EC_03:
	cpi D1,0x02			; czy TMP5 = 0x02
	brne EC_02				; nie to skok do EC_02
	rjmp E_02				; skok do E_02
EC_02:
	cpi D1,0x01			; czy TMP5 = 0x01
	brne EC_01				; nie to skok do EC_01
	rjmp E_01				; skok do E_01
EC_01:
	rjmp E_END
E_49:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+7			; wpisanie do TMP5 danej SRAM spod adresu Y+7
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+7,D1			; wpisanie TMP5 do SRAM pod adres Y+7
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_48:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x80			; ustawienie 7-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_47:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x40			; ustawienie 6-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_46:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x20			; ustawienie 5-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_45:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x10			; ustawienie 4-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_44:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x08			; ustawienie 3-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_43:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x04			; ustawienie 2-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_42:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x02			; ustawienie 1-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_41:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+6			; wpisanie do TMP5 danej SRAM spod adresu Y+6
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+6,D1			; wpisanie TMP5 do SRAM pod adres Y+6
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_40:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x80			; ustawienie 7-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_39:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x40			; ustawienie 6-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_38:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x20			; ustawienie 5-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_37:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x10			; ustawienie 4-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_36:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x08			; ustawienie 3-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_35:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x04			; ustawienie 2-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_34:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x02			; ustawienie 1-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_33:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+5			; wpisanie do TMP5 danej SRAM spod adresu Y+5
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+5,D1			; wpisanie TMP5 do SRAM pod adres Y+5
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_32:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x80			; ustawienie 7-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_31:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x40			; ustawienie 6-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_30:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x20			; ustawienie 5-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_29:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x10			; ustawienie 4-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_28:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x08			; ustawienie 3-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_27:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x04			; ustawienie 2-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_26:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x02			; ustawienie 1-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_25:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+4			; wpisanie do TMP5 danej SRAM spod adresu Y+4
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+4,D1			; wpisanie TMP5 do SRAM pod adres Y+4
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_24:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x80			; ustawienie 7-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_23:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x40			; ustawienie 6-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_22:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x20			; ustawienie 5-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_21:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x10			; ustawienie 4-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_20:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x08			; ustawienie 3-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_19:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x04			; ustawienie 2-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_18:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x02			; ustawienie 1-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_17:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+3			; wpisanie do TMP5 danej SRAM spod adresu Y+3
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+3,D1			; wpisanie TMP5 do SRAM pod adres Y+3
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_16:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x80			; ustawienie 7-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_15:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x40			; ustawienie 6-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_14:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x20			; ustawienie 5-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_13:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x10			; ustawienie 4-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_12:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x08			; ustawienie 3-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_11:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x04			; ustawienie 2-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_10:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x02			; ustawienie 1-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_09:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+2			; wpisanie do TMP5 danej SRAM spod adresu Y+2
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+2,D1			; wpisanie TMP5 do SRAM pod adres Y+2
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_08:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x80			; ustawienie 7-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_07:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x40			; ustawienie 6-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_06:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x20			; ustawienie 5-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_05:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x10			; ustawienie 4-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_04:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x08			; ustawienie 3-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_03:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x04			; ustawienie 2-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_02:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x02			; ustawienie 1-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_01:
	mov TMPL2,YL			; wpisanie YL do TMPL2
	mov TMPL3,YH			; wpisanie YH do TMPL3
	mov TMPL1,D1			; wpisanie TMP5 do TMPL1
	mov YL,XL				; wpisanie XL do YL
	mov YH,XH				; wpisanie XH do YH
	ldd D1,Y+1			; wpisanie do TMP5 danej SRAM spod adresu Y+1
	ori D1,0x01			; ustawienie 0-go bitu w TMP5
	std Y+1,D1			; wpisanie TMP5 do SRAM pod adres Y+1
	mov D1,TMPL1			; wpisanie TMPL1 do TMP5
	mov YL,TMPL2			; wpisanie TMPL2 do YL
	mov YH,TMPL3			; wpisanie TMPL3 do YH
	rjmp E_END				; skok do E_END
E_END:
	clr XL					; zerowanie XL
	clr XH					; zerowanie XH
	ret
;
ADJUST:
; Przesunicie liczby czterobajtowej (adres LSB w Y) w taki sposb by najstarszy bajt (Y+3) zaczyna si od najstarszej jedynki
	ldd TMP1,Y+2			; wpisanie do TMP1 bajtu SRAM o adresie Y+2
	std Y+3,TMP1			; wpisanie TMP1 do SRAM pod adres Y+3
	ldd TMP1,Y+1			; wpisanie do TMP1 bajtu SRAM o adresie Y+1
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ld TMP1,Y				; wpisanie do TMP1 bajtu SRAM o adresie Y
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres Y+1
	ldi TMP1,0x00			; wyzerowanie TMP1
	st Y,TMP1				; wpisanie TMP1 do SRAM pod adres Y
	ret
;
MOVE_UP:			
; przepisanie danych do grnej czci SRAM
	clr YH					; wyzerowanie YH
	ldi ZL,0xC0				; wpisanie 0x0C0 do ZL
	clr ZH					; wyzerowanie ZH
	clr TMP1				; wyzerowanie TMP1
	st Z,TMP1				; wpisanie TMP1 do SRAM pod adres Z
	std Z+1,TMP1			; wpisanie TMP1 do SRAM pod adres Z+1
	std Z+2,TMP1			; wpisanie TMP1 do SRAM pod adres Z+2
	std Z+3,TMP1			; wpisanie TMP1 do SRAM pod adres Z+3
	std Z+4,TMP1			; wpisanie TMP1 do SRAM pod adres Z+4
	std Z+5,TMP1			; wpisanie TMP1 do SRAM pod adres Z+5
	std Z+6,TMP1			; wpisanie TMP1 do SRAM pod adres Z+6
	std Z+7,TMP1			; wpisanie TMP1 do SRAM pod adres Z+7
	ld TMP1,Y				; wpisanie do TMP1 danej SRAM o adresie Y
	st Z,TMP1				; wpisanie TMP1 do SRAM pod adres Z
	ldd TMP1,Y+1			; wpisanie do TMP1 danej SRAM o adresie Y+1
	std Z+1,TMP1			; wpisanie TMP1 do SRAM pod adres Z+1
	ldd TMP1,Y+2			; wpisanie do TMP1 danej SRAM o adresie Y+2
	std Z+2,TMP1			; wpisanie TMP1 do SRAM pod adres Z+2
	nop			
	nop			
	nop			
	nop			
	nop			
	nop			
	nop			
	ret			
;
MOVE_DOWN:			
; przepisanie danych do grnej czci SRAM
	clr YH					; wyzerowanie YH
	ldi ZL,0xCE				; wpisanie 0x0CE do ZL
	clr ZH					; wyzerowanie ZH
	ld TMP1,Z				; wpisanie do TMP1 danej SRAM o adresie Z
	st Y,TMP1				; wpisanie TMP1 do SRAM pod adres Y
	ldd TMP1,Z+1			; wpisanie do TMP1 danej SRAM o adresie Z+1
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres Y+1
	ldd TMP1,Z+2			; wpisanie do TMP1 danej SRAM o adresie Z+2
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres Y+2
	ret
;
CORR:
; mnoenie liczby siedmiobajtowej przez piciobajtow
	ldi YL,0xC8				; wpisanie 0xC8 do YL
	clr YH					; wyzerowanie YH
	clr TMP1				; wyzerowanie TMP1
	st Y,TMP1				; wpisanie TMP1 do SRAM pod adres z Y
	std Y+1,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+1
	std Y+2,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+2
	std Y+3,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+3
	std Y+4,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+4
	std Y+5,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+5
	std Y+6,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+6
	std Y+7,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+7
	std Y+8,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+8
	std Y+9,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+9
	std Y+10,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+10
	std Y+11,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+11
	std Y+12,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+12
	std Y+13,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+13
	std Y+14,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+14
	std Y+15,TMP1			; wpisanie TMP1 do SRAM pod adres z Y+15
	ldi ZL,0xC0				; wpisanie 0xC0 do ZL
	mov TMPL1,ZL			; przepisanie ZL do TMPL1
	clr ZH					; wyzerowanie ZH
	ldi YL,0xB9				; wpisanie 0xB9 do YL
	mov TMPL2,YL			; przepisanie YL do TMPL2
	clr YH					; wyzerowanie YH
	ldi D2,0x07				; wpisanie 0x07 do D2
MULT8x8:
	ld TMP2,Z				; wpisanie do TMP2 danej SRAM spod adresu Z
	clr TMP3				; wyzerowanie TMP3
	call MULT8x1
	mov ZL,TMPL1			; przepisanie TMPL1 do ZL
	inc ZL					; zwikszenie ZL o 1
	mov TMPL1,ZL			; przepisanie ZL do TMPL1
	mov YL,TMPL2			; przepisanie TMPL2 do YL
	dec D2					; zmniejszenie D2 o 1
	brne MULT8x8			; gdy D2 rone od zera to skok do MULT8x8
	clr TMP3				; wyzerowanie TMP3
	ldi ZL,0xCD				; wpisanie 0xCD do ZL
	ld TMP1,Z				; wpisanie do TMP1 danej SRAM spod adresu Z
	rol TMP1				; rotacja w lewo TMP1 z wykorzystaniem flagi C
	ldd TMP1,Z+1			; wpisanie do TMP1 danej SRAM spod adresu Z+1
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+1,TMP1			; wpisanie TMP1 do SRAM pod adres Z+1
	ldd TMP1,Z+2			; wpisanie do TMP1 danej SRAM spod adresu Z+2
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+2,TMP1			; wpisanie TMP1 do SRAM pod adres Z+2
	ldd TMP1,Z+3			; wpisanie do TMP1 danej SRAM spod adresu Z+3
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+3,TMP1			; wpisanie TMP1 do SRAM pod adres Z+3
	ldd TMP1,Z+4			; wpisanie do TMP1 danej SRAM spod adresu Z+4
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+4,TMP1			; wpisanie TMP1 do SRAM pod adres Z+4
	ldd TMP1,Z+5			; wpisanie do TMP1 danej SRAM spod adresu Z+5
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+5,TMP1			; wpisanie TMP1 do SRAM pod adres Z+5
	ldd TMP1,Z+6			; wpisanie do TMP1 danej SRAM spod adresu Z+6
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+6,TMP1			; wpisanie TMP1 do SRAM pod adres Z+6
	ldd TMP1,Z+7			; wpisanie do TMP1 danej SRAM spod adresu Z+7
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+7,TMP1			; wpisanie TMP1 do SRAM pod adres Z+7
	ldd TMP1,Z+8			; wpisanie do TMP1 danej SRAM spod adresu Z+8
	adc TMP1,TMP3			; dodanie TMP3 z Carry do TMP1
	std Z+8,TMP1			; wpisanie TMP1 do SRAM pod adres Z+8
	ret
MULT8x1:
; mnoenie liczby max 8-io bajtowej przez jednobajtow
	nop
	nop
	nop
	ldi D3,0x07
MULT8x1_L:
	ld TMP1,Y				; wpisanie do TMP1 danej SRAM spod adresu Y
	clr TMP3				; wyzerowanie TMP3
	mul TMP1,TMP2			; mnoenie TMP1 przez TMP2
	ldd TMP1,Z+8			; wpisanie do TMP1 bajtu SRAM spod adresu Z+8
	add TMP1,RL				; dodanie RL do TMP1
	std Z+8,TMP1			; wpisanie TMP1 do SRAM pod adres Z+8
	ldd TMP1,Z+9			; wpisanie do TMP1 bajtu SRAM spod adresu Z+1
	adc TMP1,RH				; dodanie z Carry TMP1 do RH
	std Z+9,TMP1			; wpisanie TMP1 do SRAM pod adres Z+1
	ldd TMP1,Z+10			; wpisanie do TMP1 bajtu SRAM spod adresu Z+2
	adc TMP1,TMP3			; dodanie z Carry TMP3 do TMP3=0
	std Z+10,TMP1			; wpisanie TMP1 do SRAM pod adres Z+2
	ldd TMP1,Z+11			; wpisanie do TMP1 bajtu SRAM spod adresu Z+3
	adc TMP1,TMP3			; dodanie z Carry TMP1 do TMP3=0
	std Z+11,TMP1			; wpisanie TMP1 do SRAM pod adres Z+3
	ldd TMP1,Z+12			; wpisanie do TMP1 bajtu SRAM spod adresu Z+4
	adc TMP1,TMP3			; dodanie z Carry TMP1 do TMP3=0
	std Z+12,TMP1			; wpisanie TMP1 do SRAM pod adres Z+4
	ldd TMP1,Z+13			; wpisanie do TMP1 bajtu SRAM spod adresu Z+5
	adc TMP1,TMP3			; dodanie z Carry TMP1 do TMP3=0
	std Z+13,TMP1			; wpisanie TMP1 do SRAM pod adres Z+5
	ldd TMP1,Z+14			; wpisanie do TMP1 bajtu SRAM spod adresu Z+6
	adc TMP1,TMP3			; dodanie z Carry TMP1 do TMP3=0
	std Z+14,TMP1			; wpisanie TMP1 do SRAM pod adres Z+6
	ldd TMP1,Z+15			; wpisanie do TMP1 bajtu SRAM spod adresu Z+7
	adc TMP1,TMP3			; dodanie z Carry TMP1 do TMP3=0
	std Z+15,TMP1			; wpisanie TMP1 do SRAM pod adres Z+7
	inc YL					; zwikszenie YL o 1
	inc ZL					; zwikszenie ZL o 1
	nop
	nop
	nop
	nop
	nop
	nop
	dec D3					; zmniejszenie D3 o 1
	brne MULT8x1_L			; gdy D3 rne od zera to skok do MULT8x1_L
	nop
	nop
	nop
	nop
	nop
	ret			
;
	.org 0x1FFC
	.dw 0x9915
	.dw 0x4299
	.dw 0x9000
	.dw 0x0000
;
